//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:17:03 sutner> 
//
// :File:     basic.cc
// :Purpose:  Helper functions.
//---------------------------------------------------------------------------

#include "basic.h"
#include <stdio.h>

void  Error( const char *msg )
{
    cerr << "error: " << msg << endl;
}

//--------------------------------------------------------------------------------
// Trans (rather than III_Triple)

bool  operator==( const Trans& S, const Trans& T )
{
    return  S.p == T.p && S.s == T.s && S.q == T.q;
}

bool  operator<( const Trans& S, const Trans& T )
{
    return ( S.p < T.p || ( S.p == T.p && S.s < T.s ) ||
	     ( S.p == T.p && S.s == T.s && S.q < T.q ) );
}

ostream&  operator<<( ostream& os, const Trans& T )
{
    Format  fmt;
    os << fmt.lp << T.p << "," << T.s << "," << T.q << fmt.rp;
    return os;
}




//----------------------------------------------------------------------
// so we don't need math lib 

int  ipow( int b, int e )
{
    long int z = 1L, x = b;
    while( e > 0 )
    {
	if( e & 1 )
	    z *= x;
	x = x*x;
	e >>= 1;
    }
    return z;
}

int   random( int a, int b )
{
    return  ( a + rand() % (b - a + 1) );
}

void  write_string( char*& p, const char* s )
{
    delete p;
    p = new char[strlen(s)+1];
    strcpy( p, s );
}

//--------------------------------------------------------------------------------


void  get_res_size( char* name )
{
    string st;
    st = "ps -u|fgrep " + string(name) + "|fgrep -v fgrep|awk '{printf $5 \"  \" $6 \"\\n\"}'";
    cout << "memory: " << flush;
    system( st.c_str() ); 
}

//------------------------------------------------------------------------------
