//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:18:43 sutner> 
//
// :File:      circulant.cc
// :Purpose:   generate circulants  C(n;d1,d2,...) for zig-zag decomposition
//             
//             out-degree d != 2 currently not implemented
//---------------------------------------------------------------------------

#include  "stl-wrap.h"
#include  "getopt.h"

#include  <iostream>
#include  <fstream>
#include  <list>
#include  <vector>


typedef   list<int>  ilist;

//--------------------------------------------------------------------------------


int  process_cmdline( int argc, char **argv, size_t& n, ilist& D  )
{
    if( argc == 1 )
    {
	cerr << "Usage: " << argv[0] << " n d1 d2 ... " << endl;
	exit(0);
    }

    n  = atoi( argv[1] );

    for( int i = 2; i < argc; ++i )
	D.push_back( atoi( argv[i] ) );
   
    return D.size();
}

//--------------------------------------------------------------------------------
    
main( int argc, char **argv )
{
    size_t  n;
    ilist   D;
    ilist::iterator  it;
    
    process_cmdline( argc, argv, n, D );

    cout << "Graph" << endl;
    cout << n << endl;
    for( size_t i = 0; i < n; ++i )
    {
	foreach_item( it, D )
	    {
		int z = int(i) + *it;
		if( z < 0 )  z += n;
		if( z >= int(n) )  z -= n;
		cout  <<  setw(4) << (z + 1);
	    }
	cout << endl;
    }
}
