//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:19:22 sutner> 
//
// :File:      circulant.cc
// :Purpose:   generate circulants  C(n;d1,d2,...) for zig-zag decomposition
//             
//             out-degree d != 2 currently not implemented
//---------------------------------------------------------------------------

#include  "stl-wrap.h"
#include  "getopt.h"

#include  <iostream>
#include  <iomanip>
#include  <fstream>
#include  <list>
#include  <vector>


typedef   list<int>  ilist;

//--------------------------------------------------------------------------------

size_t  ipow( size_t b, int e )
{
    size_t z = 1U, x = b;
    while( e > 0 )
    {
	if( e & 1 )
	    z *= x;
	x *= x;
	e >>= 1;
    }
    return z;
}


void  process_cmdline( int argc, char **argv, size_t& w, size_t& k  )
{
    if( argc == 1 )
    {
	cerr << "Usage: " << argv[0] << " w k" << endl;
	exit(0);
    }

    w  = atoi( argv[1] );
    if( argc == 3 )
	k = atoi( argv[2] );
    else
	k = 2;
}

//--------------------------------------------------------------------------------
    
main( int argc, char **argv )
{
    size_t  w, k, kw;
    
    process_cmdline( argc, argv, w, k );

    kw  = ipow( k, w );
    
    cout << "Graph" << endl;
    cout <<  kw << endl;
    for( size_t a = 0; a < k; ++a )
	for( size_t z = 0, b = 0; z < kw; ++z )
	{
	    cout << setw(4) << (z+1);
	    if( ++b == k ) 
	    {
		cout << endl; b = 0;
	    }
	}
}
