//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-25 18:25:31 sutner> 
//
// :File:      extaut.cc
// :Purpose:   main for MathLink, global symbol table
//             
//---------------------------------------------------------------------------


#include  <cctype>
#include  <cstdlib>
#include  <fstream>

#include  "globop.h"
#include  "listutil.h"
#include  "makeatom.h"
#include  "parser.h"
#include  "ptree.h"
#include  "symtab.h"
#include  "urlist.h"
#include  "extoutput.h"

extern "C"
{
#include  "mathlink.h"
}

//----------------------------------------------------------------------
//  the MathLink parser

Parser    *ml_parser;		// a quiet parser
SymTable  *ml_env;		// its symbol table
ofstream   ml_logfile;		// log file for MathLink traffic
bool       ml_logflag;		// control logging

// output formatting

char  *Format::lp = "{";
char  *Format::rp = "}";
char  *Format::cm = ", ";


int     ML_needs_token;

extern "C" 
{
   void   ML_parse( char *instr );
   void   ML_control( char *instr );
}

// Mathematica transmits  newlines as  '\''0''1''2'
static  void  fix_newlines( char *bf )
{
    char  *p = bf;
    while( *p != '\0' )
	if( *p == '\\' && *(p+1) == '0' && *(p+2) == '1' && *(p+3) == '2' )
	{
	    *p++ = '\n'; *p++ = ' '; *p++ = ' '; *p++ = ' ';
	}
	else
	    p++;
}

//--------------------------------------------------------------------------------
// primitive control
// should have time stamps
// messages

void   ML_control( char *str )
{
    extern  ofstream  ml_logfile;
    extern  bool  ml_logflag;

    int k = atoi( str );
	  
    if( k == 2 )
    {
	ml_logfile.open("/home/sutner/ml_log",ios::app);
	ml_logflag = 1;
	cerr << "log open (append)" << endl;
	return;
    }
    
    if( k == 1 )
    {
	ml_logfile.open("/home/sutner/ml_log");
	ml_logflag = 1;
	cerr << "log open (append)" << endl;
	return;
    }
    
    if( k == 0 )
    {
	ml_logfile.close();
	ml_logflag = 0;
	cerr << "log closed" << endl;
	return;
    }
}

//--------------------------------------------------------------------------------
// total kludge, control logging from separate function
// ExtAutomataLog[] 
// 

void   ML_parse( char *instr )
{
    extern  ofstream  ml_logfile;
    extern  bool  ml_logflag;
    
    fix_newlines( instr );
    
    if( ml_logflag ) ml_logfile << "> " << instr << endl;

    ml_parser->attach( "string", instr );

    ML_needs_token = 1;
    UList  val = ml_parser->parse( *ml_env );

    if( ml_parser->is_go() ) 
    {
	if( ML_needs_token )
	    if( ml_parser->do_print() )
	    {
		ML_write_urlist( val );
		if( ml_logflag ) ml_logfile << val << endl;
	    }
	    else
	    {
		MLPutSymbol( stdlink, "Null" );
		if( ml_logflag ) ml_logfile << "Null" << endl;
	    }
    }
    else
    {
	MLPutSymbol( stdlink, "$Failed" );
	if( ml_logflag ) ml_logfile << "$Failed" << endl;
    }
}

//----------------------------------------------------------------------

int  main( int argc, char *argv[] )
{
    ml_parser = new Parser;
    ml_env    = new SymTable(NULL);
    
    MLMain( argc, argv );

    delete  ml_parser;
    delete  ml_env;
    
    return EXIT_SUCCESS;
}

//----------------------------------------------------------------------


