//--------------------------------------------------------------------------------
//
// Time-stamp: <2003-11-24 18:20:32 sutner>
// 
// File:     fsmprint.cc
// Purpose:  primitive printing for fms's
//
//--------------------------------------------------------------------------------

#include  "stl-wrap.h"
#include  "fsm.h"
#include  "urlist.h"
#include  "listutil.h"
#include  "util.h"

//--------------------------------------------------------------------------------

ostream& operator<<( ostream& out, const FSMachine& M )
{
   out << "FSM[ " << M.numStates() << COMMA << M.numSymbols() << "]";
   return out;
}

ostream& operator<<( ostream& out, const SA& M )
{
   out << "SA[ " << M.numStates() << COMMA << M.numSymbols() << COMMA; 
   ::PrintTransitions( out, M.transitions(), 1 );
   out << "]";
   return out;
}

ostream& operator<<( ostream& out, const FA& M )
{
   out << "FA[ " << M.numStates() << COMMA << M.numSymbols() << COMMA; 
   ::PrintTransitions( out, M.transitions(), 1 );
   out << COMMA;
   Print( out, M.initial(), 1 ); 
   out << COMMA;
   Print( out, M.final(), 1 ); 
   out << "]";
   return out;
}

ostream& operator<<( ostream& out, const DFA& M )
{
   out << "DFA[ " << M.numStates() << COMMA << M.numSymbols() << COMMA; 
   const vector<size_t>  &tr = M.transitions();
   ::PrintMatrixManip( out, tr.begin(), tr.size(),
		       bind2nd(plus<int>(),1), M.numStates() );
   out << COMMA << M.initial() + 1;
   out << COMMA;
   Print( out, M.final(), 1 ); 
   out << "]";
   return out;
}

//---------------------------------------------------------------------


