//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:37:32 sutner> 
//
// :File:      chebyshev.cc
// :Purpose:   charVec  is a compact representation for doubly symmetric
//             matrices over GF(2)
//             
//---------------------------------------------------------------------------

#ifndef  _CHEBYSHEV_H_
#define  _CHEBYSHEV_H_


//#include  <stdlib.h> 
//#include  <ctype.h>
 
#include  "basic.h"
#include  "bitvect.h"
#include  "urlist.h" 
#include  "atom.h"

//----------------------------------------------------------------------
//  wrapper functions 

UList   piMatrix( UList L );
UList   make_matrix( int m, int n, int sigmatype, int prnmat, int prnall );

//----------------------------------------------------------------------
//  charVec


#define    VECLEVELS(m)  ((m)+1)/2
#define    VECSIZE(m)    ((m) & 1)?(((m)>>1)+1)*(((m)>>1)+1):((m)>>1)*(((m)>>1)+1)


class boolVec:  public  vector<bool>
{
    size_t  _dep;			// number of partial rows
    size_t  _mm;			// size of original matrix
   
public:

    boolVec() {}
    boolVec( size_t m ): vector<bool>(VECSIZE(m)), _dep(VECLEVELS(m)), _mm(m) {}

    ~boolVec(){}
   
    boolVec( const boolVec& src );
    boolVec&  operator=( const boolVec& A );
    bool      operator==( const boolVec& A );
   
    void  setValue( bool b=0 );

				// C = *this + B
    void   addmatrix( const boolVec& B, boolVec& C ) const;
    void   multsigma( boolVec& B, bool which ) const;
    void   expand_to_bitmatrix( BitMatrix& M );
   
};


#endif 





