//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:38:19 sutner> 
//
//  :File:      MLoutput.h
//  :Purpose:   output for ULists to MathLink
//---------------------------------------------------------------------------

#ifndef  _OUTPUT_H_
#define  _OUTPUT_H_

#include  "basic.h"
#include  "urlist.h"
#include  "useratom.h"
#include  "listutil.h"
#include  "parser.h"
#include  "ptree.h"
#include  "symtab.h"

//----------------------------------------------------------------------
// sending values and sending D-classes as side-effect 

void     ML_write_urlist( UList LL );
UList    ML_write_dclasses( UList L );

//--------------------------------------------------------------------------------
// various helpers

void   ML_write( const Triple<int,int,int>& pp, int offset=0 );  
void   ML_write( const TransV& A, int offset=0 );
void   ML_write( const ivector& A, int offset=0 );
void   ML_write( const uvector& A, int offset=0 );
void   ML_write( const ilist& S, int offset=0 );
void   ML_write( const ulist& S, int offset=0 );
void   ML_write( const IntSet& S, int offset=0 );
void   ML_write( const vector<string>& wit );
void   ML_write( const list<Pair<string,string> >& equ );

void   ML_write_sg( const ivector& sg, int onefl, int w );
void   ML_write_dc( const DClass& dcl );
void   ML_write_dc_array( const vector<DClass>& dcl );
void   ML_write( const DClass& dc );

#endif






