//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:38:42 sutner> 
//
//  :File:      globop.h
//  :Purpose:   Standard operations for automata calculator.
// 
//---------------------------------------------------------------------------

#ifndef  _AUTO_H_
#define  _AUTO_H_

#include  "Clock.h"
#include  "basic.h"
#include  "listutil.h"
#include  "makeatom.h"
#include  "parser.h"
#include  "ptree.h"
#include  "symtab.h"
#include  "urlist.h"
#include  "chebyshev.h"

//--------------------------------------------------------------------------------
// used in ParserInitializer

void   load_standard_operators( SymTable& stab );
void   load_from_global( TokenHTab& ht );

//--------------------------------------------------------------------------------
// helper functions, some should be inlined

UList   print_globals();

UList   at_i( UList L, UList i );
UList   equal_ul( UList x, UList y );
UList   less_ul( UList x, UList y );

int  and_ii( int x, int y );
int  greater_ii( int x, int y );
int  not_i( int x );
int  or_ii( int x, int y );
int  positive_i( int x );

int  add_ii( int x, int y );
int  dec_i( int x );
int  div_ii( int x, int y );
int  inc_i( int x );
int  mult_ii( int x, int y );
int  sub_ii( int x, int y );


//--------------------------------------------------------------------------------
// reading with `read()'

UList  read_expression();
UList  openread( UList L );
UList  closeread();

//--------------------------------------------------------------------------------
#endif
