//---------------------------------------------------------------------------
//
//  Time-stamp: <2003-11-24 18:28:00 sutner> 
//
// :File:      smodtest.cc
// :Purpose:   testing templated semimodule generation
//---------------------------------------------------------------------------


#include  <cctype>
#include  <iostream>
#include  <hash_map.h>
#include  <algorithm>

#include  "stl-wrap.h"
#include  "basic.h"
#include  "pairs.h"
#include  "semimod.h"

//--------------------------------------------------------------------------------

typedef  vector<int>   ivector;

struct  foofoo:  public  binary_function<ivector,size_t,ivector>
{
    foofoo() {}

    ivector  operator()( const ivector& a, size_t b ) const
    {
	ivector  res(a);
	if( b )
	    rotate( res.begin(), res.begin()+1, res.end() );
	else
	    if( res[0] ) res[0]--;
	return res;
    }
    
};

//--------------------------------------------------------------------------------
// Cartesian products

// struct  prod_trans: public binary_function<size_t,size_t,size_t>
// {
//     const uvector  &T1, &T2;
//     size_t   kk, nn1, nn2;
    
//     prod_trans( const uvector& t1, const uvector& t2, size_t k, size_t n1, size_t n2 ):
// 	T1(t1), T2(t2), kk(k), nn1(n1), nn2(n2) {}

//     size_t  operator()( size_t p, size_t s ) const 
//     {
// 	return  pcode( nn2, T1[ s*nn1 + pdecode1(nn2,p) ], T2[ s*nn2 + pdecode2(nn2,p) ] );
//     }
// };

struct  prod_trans: public binary_function<uupair,size_t,uupair>
{
    const uvector  &T1, &T2;
    size_t   kk, nn1, nn2;
    
    prod_trans( const uvector& t1, const uvector& t2, size_t k, size_t n1, size_t n2 ):
	T1(t1), T2(t2), kk(k), nn1(n1), nn2(n2) {}

    uupair  operator()( uupair p, size_t s ) const 
    {
	return  uupair( T1[ s*nn1 + p.first ], T2[ s*nn2 + p.second ] );
    }
};

ostream&  operator<<( ostream& os, uupair p )
{
    os << "(" << p.first << "," << p.second << ")";
    return os;
}





main( int argc, char **argv )
{
//    size_t n = atoi(argv[1]);
//    size_t k = atoi(argv[2]);



    int  A[] = { 0,1,2,     1,2,0 };
    int  B[] = { 1,2,2,2,0, 0,1,4,1,3 };
    
    uvector  T1(6), T2(10);
    copy( A, A+6, T1.begin() );
    copy( B, B+10, T2.begin() );

    cout << T1 << "   " << T2 << endl;

    prod_trans   pt( T1, T2, 2, 3, 5 );

    uupair   zero(0,0);
    SemiModule<uupair,prod_trans> SM( 2, zero, pt );

    cout << SM.generate() << endl;

    hash<uupair>  H;

    SemiModule<uupair,prod_trans>::iterator  ssit;
    for( ssit = SM.Q.begin(); ssit != SM.Q.end(); ++ssit )
    {
	cout << ssit->first << "  " << ssit->second << "\t" << H(ssit->first) << endl;
    }
    
    
}


