(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     64866,       3278]*)
(*NotebookOutlinePosition[    117004,       4923]*)
(*  CellTagsIndexPosition[    103923,       4514]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["Automata", "IndexSection",
  CellTags->"MasterIndexHeading"],

Cell[TextData[{
  "   ",
  ButtonBox["AlgebraicForm",
    ButtonData:>"AlgebraicForm",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AlgebraicForm"],

Cell[TextData[{
  "   ",
  ButtonBox["Alphabet",
    ButtonData:>"Alphabet",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Alphabet"],

Cell[TextData[{
  "   ",
  ButtonBox["AlphabetQ",
    ButtonData:>"AlphabetQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AlphabetQ"],

Cell[TextData[{
  "   ",
  ButtonBox["AlphabetSize",
    ButtonData:>"AlphabetSize",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AlphabetSize"],

Cell[TextData[{
  "   ",
  ButtonBox["Concatenate",
    ButtonData:>"Concatenate",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Concatenate"],

Cell[TextData[{
  "   ",
  ButtonBox["Eps",
    ButtonData:>"Eps",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Eps"],

Cell[TextData[{
  "   ",
  ButtonBox["FromEps",
    ButtonData:>"FromEps",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FromEps"],

Cell[TextData[{
  "   ",
  ButtonBox["FromFrontier",
    ButtonData:>"FromFrontier",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FromFrontier"],

Cell[TextData[{
  "   ",
  ButtonBox["FrontierQ",
    ButtonData:>"FrontierQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FrontierQ"],

Cell[TextData[{
  "   ",
  ButtonBox["MakeAlphabet",
    ButtonData:>"MakeAlphabet",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MakeAlphabet"],

Cell[TextData[{
  "   ",
  ButtonBox["MakeWord",
    ButtonData:>"MakeWord",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MakeWord"],

Cell[TextData[{
  "   ",
  ButtonBox["ParikhVector",
    ButtonData:>"ParikhVector",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ParikhVector"],

Cell[TextData[{
  "   ",
  ButtonBox["RandomWord",
    ButtonData:>"RandomWord",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RandomWord"],

Cell[TextData[{
  "   ",
  ButtonBox["ToBlocks",
    ButtonData:>"ToBlocks",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToBlocks"],

Cell[TextData[{
  "   ",
  ButtonBox["ToEps",
    ButtonData:>"ToEps",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToEps"],

Cell[TextData[{
  "   ",
  ButtonBox["ToFrontier",
    ButtonData:>"ToFrontier",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToFrontier"],

Cell[TextData[{
  "   ",
  ButtonBox["ToIndex",
    ButtonData:>"ToIndex",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToIndex"],

Cell[TextData[{
  "   ",
  ButtonBox["ToWord",
    ButtonData:>"ToWord",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToWord"],

Cell[TextData[{
  "   ",
  ButtonBox["WordBinomial",
    ButtonData:>"WordBinomial",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordBinomial"],

Cell[TextData[{
  "   ",
  ButtonBox["WordConjugateQ",
    ButtonData:>"WordConjugateQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordConjugateQ"],

Cell[TextData[{
  "   ",
  ButtonBox["WordConjugates",
    ButtonData:>"WordConjugates",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordConjugates"],

Cell[TextData[{
  "   ",
  ButtonBox["WordFactorizations",
    ButtonData:>"WordFactorizations",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordFactorizations"],

Cell[TextData[{
  "   ",
  ButtonBox["WordFactorQ",
    ButtonData:>"WordFactorQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordFactorQ"],

Cell[TextData[{
  "   ",
  ButtonBox["WordFactors",
    ButtonData:>"WordFactors",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordFactors"],

Cell[TextData[{
  "   ",
  ButtonBox["WordFusion",
    ButtonData:>"WordFusion",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordFusion"],

Cell[TextData[{
  "   ",
  ButtonBox["WordLength",
    ButtonData:>"WordLength",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordLength"],

Cell[TextData[{
  "   ",
  ButtonBox["WordOrder",
    ButtonData:>"WordOrder",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordOrder"],

Cell[TextData[{
  "   ",
  ButtonBox["WordPeriod",
    ButtonData:>"WordPeriod",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordPeriod"],

Cell[TextData[{
  "   ",
  ButtonBox["WordPower",
    ButtonData:>"WordPower",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordPower"],

Cell[TextData[{
  "   ",
  ButtonBox["WordPrefixQ",
    ButtonData:>"WordPrefixQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordPrefixQ"],

Cell[TextData[{
  "   ",
  ButtonBox["WordPrefixes",
    ButtonData:>"WordPrefixes",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordPrefixes"],

Cell[TextData[{
  "   ",
  ButtonBox["WordPrimitiveCount",
    ButtonData:>"WordPrimitiveCount",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordPrimitiveCount"],

Cell[TextData[{
  "   ",
  ButtonBox["WordPrimitiveQ",
    ButtonData:>"WordPrimitiveQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordPrimitiveQ"],

Cell[TextData[{
  "   ",
  ButtonBox["WordQ",
    ButtonData:>"WordQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordQ"],

Cell[TextData[{
  "   ",
  ButtonBox["WordReverse",
    ButtonData:>"WordReverse",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordReverse"],

Cell[TextData[{
  "   ",
  ButtonBox["WordRoot",
    ButtonData:>"WordRoot",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordRoot"],

Cell[TextData[{
  "   ",
  ButtonBox["WordRotate",
    ButtonData:>"WordRotate",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordRotate"],

Cell[TextData[{
  "   ",
  ButtonBox["Words",
    ButtonData:>"Words",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Words"],

Cell[TextData[{
  "   ",
  ButtonBox["WordShuffle",
    ButtonData:>"WordShuffle",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordShuffle"],

Cell[TextData[{
  "   ",
  ButtonBox["WordSort",
    ButtonData:>"WordSort",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordSort"],

Cell[TextData[{
  "   ",
  ButtonBox["WordSuffixQ",
    ButtonData:>"WordSuffixQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordSuffixQ"],

Cell[TextData[{
  "   ",
  ButtonBox["WordSuffixes",
    ButtonData:>"WordSuffixes",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordSuffixes"],

Cell[TextData[{
  "   ",
  ButtonBox["AcceptQFA",
    ButtonData:>"AcceptQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AcceptQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["AccessibleFA",
    ButtonData:>"AccessibleFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AccessibleFA"],

Cell[TextData[{
  "   ",
  ButtonBox["AddTransitionFA",
    ButtonData:>"AddTransitionFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AddTransitionFA"],

Cell[TextData[{
  "   ",
  ButtonBox["AllDFA",
    ButtonData:>"AllDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AllDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["AmbiguousQFA",
    ButtonData:>"AmbiguousQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AmbiguousQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["BEFA",
    ButtonData:>"BEFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BEFA"],

Cell[TextData[{
  "   ",
  ButtonBox["BEFAToFA",
    ButtonData:>"BEFAToFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BEFAToFA"],

Cell[TextData[{
  "   ",
  ButtonBox["BehaviorFA",
    ButtonData:>"BehaviorFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BehaviorFA"],

Cell[TextData[{
  "   ",
  ButtonBox["BuildBEFA",
    ButtonData:>"BuildBEFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BuildBEFA"],

Cell[TextData[{
  "   ",
  ButtonBox["BuildDFA",
    ButtonData:>"BuildDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BuildDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["BuildNNFA",
    ButtonData:>"BuildNNFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BuildNNFA"],

Cell[TextData[{
  "   ",
  ButtonBox["BuildStarDFA",
    ButtonData:>"BuildStarDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BuildStarDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["CirculantSA",
    ButtonData:>"CirculantSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CirculantSA"],

Cell[TextData[{
  "   ",
  ButtonBox["CoAccessibleFA",
    ButtonData:>"CoAccessibleFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CoAccessibleFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ComplementFA",
    ButtonData:>"ComplementFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ComplementFA"],

Cell[TextData[{
  "   ",
  ButtonBox["CompleteFA",
    ButtonData:>"CompleteFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CompleteFA"],

Cell[TextData[{
  "   ",
  ButtonBox["CompleteQFA",
    ButtonData:>"CompleteQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CompleteQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ComputationFA",
    ButtonData:>"ComputationFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ComputationFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ComputationGraphFA",
    ButtonData:>"ComputationGraphFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ComputationGraphFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ConcatenateFA",
    ButtonData:>"ConcatenateFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ConcatenateFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ConvertToFA",
    ButtonData:>"ConvertToFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ConvertToFA"],

Cell[TextData[{
  "   ",
  ButtonBox["CounterDFA",
    ButtonData:>"CounterDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CounterDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["CoverQDFA",
    ButtonData:>"CoverQDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CoverQDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["DefiniteQFA",
    ButtonData:>"DefiniteQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DefiniteQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["DegreesFA",
    ButtonData:>"DegreesFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DegreesFA"],

Cell[TextData[{
  "   ",
  ButtonBox["DeleteStateFA",
    ButtonData:>"DeleteStateFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeleteStateFA"],

Cell[TextData[{
  "   ",
  ButtonBox["DeterministicQFA",
    ButtonData:>"DeterministicQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeterministicQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["DFA",
    ButtonData:>"DFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DFA"],

Cell[TextData[{
  "   ",
  ButtonBox["DivisibilityDFA",
    ButtonData:>"DivisibilityDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DivisibilityDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["EmptyDFA",
    ButtonData:>"EmptyDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EmptyDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["EmptyQFA",
    ButtonData:>"EmptyQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EmptyQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["EpsilonFreeQ",
    ButtonData:>"EpsilonFreeQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EpsilonFreeQ"],

Cell[TextData[{
  "   ",
  ButtonBox["EpsilonEliminationFA",
    ButtonData:>"EpsilonEliminationFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EpsilonEliminationFA"],

Cell[TextData[{
  "   ",
  ButtonBox["EquivalentQFA",
    ButtonData:>"EquivalentQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EquivalentQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["FactorialQFA",
    ButtonData:>"FactorialQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FactorialQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["FA",
    ButtonData:>"FA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FA"],

Cell[TextData[{
  "   ",
  ButtonBox["FinalVectorFA",
    ButtonData:>"FinalVectorFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FinalVectorFA"],

Cell[TextData[{
  "   ",
  ButtonBox["Final",
    ButtonData:>"Final",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Final"],

Cell[TextData[{
  "   ",
  ButtonBox["FiniteComplementSA",
    ButtonData:>"FiniteComplementSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FiniteComplementSA"],

Cell[TextData[{
  "   ",
  ButtonBox["FrontierToDFA",
    ButtonData:>"FrontierToDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FrontierToDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["FSMQ",
    ButtonData:>"FSMQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FSMQ"],

Cell[TextData[{
  "   ",
  ButtonBox["FullQFA",
    ButtonData:>"FullQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FullQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["FullTransitionMatrixFA",
    ButtonData:>"FullTransitionMatrixFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FullTransitionMatrixFA"],

Cell[TextData[{
  "   ",
  ButtonBox["FullTransitions",
    ButtonData:>"FullTransitions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FullTransitions"],

Cell[TextData[{
  "   ",
  ButtonBox["FunctionToDFA",
    ButtonData:>"FunctionToDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FunctionToDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["FunctionToSA",
    ButtonData:>"FunctionToSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FunctionToSA"],

Cell[TextData[{
  "   ",
  ButtonBox["GenerateDFA",
    ButtonData:>"GenerateDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GenerateDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["GenerateQuotients",
    ButtonData:>"GenerateQuotients",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GenerateQuotients"],

Cell[TextData[{
  "   ",
  ButtonBox["GrowthSeriesDFA",
    ButtonData:>"GrowthSeriesDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GrowthSeriesDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["HomomorphismFA",
    ButtonData:>"HomomorphismFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"HomomorphismFA"],

Cell[TextData[{
  "   ",
  ButtonBox["HurwitzProduct",
    ButtonData:>"HurwitzProduct",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"HurwitzProduct"],

Cell[TextData[{
  "   ",
  ButtonBox["IdealBaseFA",
    ButtonData:>"IdealBaseFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IdealBaseFA"],

Cell[TextData[{
  "   ",
  ButtonBox["IdealQFA",
    ButtonData:>"IdealQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IdealQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["InfiniteQFA",
    ButtonData:>"InfiniteQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"InfiniteQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["InitialVectorFA",
    ButtonData:>"InitialVectorFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"InitialVectorFA"],

Cell[TextData[{
  "   ",
  ButtonBox["Initial",
    ButtonData:>"Initial",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Initial"],

Cell[TextData[{
  "   ",
  ButtonBox["IntersectionFA",
    ButtonData:>"IntersectionFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IntersectionFA"],

Cell[TextData[{
  "   ",
  ButtonBox["IrreducibleFA",
    ButtonData:>"IrreducibleFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IrreducibleFA"],

Cell[TextData[{
  "   ",
  ButtonBox["IsomorphicQDFA",
    ButtonData:>"IsomorphicQDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IsomorphicQDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["IthSymbolFA",
    ButtonData:>"IthSymbolFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IthSymbolFA"],

Cell[TextData[{
  "   ",
  ButtonBox["JoinSA",
    ButtonData:>"JoinSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"JoinSA"],

Cell[TextData[{
  "   ",
  ButtonBox["LanguageFA",
    ButtonData:>"LanguageFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LanguageFA"],

Cell[TextData[{
  "   ",
  ButtonBox["LanguageSort",
    ButtonData:>"LanguageSort",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LanguageSort"],

Cell[TextData[{
  "   ",
  ButtonBox["LanguageToSeries",
    ButtonData:>"LanguageToSeries",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LanguageToSeries"],

Cell[TextData[{
  "   ",
  ButtonBox["LeftQuotient",
    ButtonData:>"LeftQuotient",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LeftQuotient"],

Cell[TextData[{
  "   ",
  ButtonBox["LengthDFA",
    ButtonData:>"LengthDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LengthDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["LocalQSA",
    ButtonData:>"LocalQSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LocalQSA"],

Cell[TextData[{
  "   ",
  ButtonBox["LocalUniversalFA",
    ButtonData:>"LocalUniversalFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LocalUniversalFA"],

Cell[TextData[{
  "   ",
  ButtonBox["LoopAutomatonFA",
    ButtonData:>"LoopAutomatonFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LoopAutomatonFA"],

Cell[TextData[{
  "   ",
  ButtonBox["MakeHomomorphismDFA",
    ButtonData:>"MakeHomomorphismDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MakeHomomorphismDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["MakeHomomorphism",
    ButtonData:>"MakeHomomorphism",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MakeHomomorphism"],

Cell[TextData[{
  "   ",
  ButtonBox["MatrixToTransitions",
    ButtonData:>"MatrixToTransitions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MatrixToTransitions"],

Cell[TextData[{
  "   ",
  ButtonBox["MinimalFischerFA",
    ButtonData:>"MinimalFischerFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MinimalFischerFA"],

Cell[TextData[{
  "   ",
  ButtonBox["MinimizeDFA",
    ButtonData:>"MinimizeDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MinimizeDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["MinimizeFA",
    ButtonData:>"MinimizeFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MinimizeFA"],

Cell[TextData[{
  "   ",
  ButtonBox["NFA",
    ButtonData:>"NFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NFA"],

Cell[TextData[{
  "   ",
  ButtonBox["NNFAToFA",
    ButtonData:>"NNFAToFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NNFAToFA"],

Cell[TextData[{
  "   ",
  ButtonBox["NNFA",
    ButtonData:>"NNFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NNFA"],

Cell[TextData[{
  "   ",
  ButtonBox["NormalizeControl",
    ButtonData:>"NormalizeControl",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NormalizeControl"],

Cell[TextData[{
  "   ",
  ButtonBox["NormalizeFA",
    ButtonData:>"NormalizeFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NormalizeFA"],

Cell[TextData[{
  "   ",
  ButtonBox["NumberOfDFA",
    ButtonData:>"NumberOfDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NumberOfDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["NumTransitions",
    ButtonData:>"NumTransitions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NumTransitions"],

Cell[TextData[{
  "   ",
  ButtonBox["PermutationSA",
    ButtonData:>"PermutationSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PermutationSA"],

Cell[TextData[{
  "   ",
  ButtonBox["PermuteFA",
    ButtonData:>"PermuteFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PermuteFA"],

Cell[TextData[{
  "   ",
  ButtonBox["PrintFA",
    ButtonData:>"PrintFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PrintFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ProductFA",
    ButtonData:>"ProductFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ProductFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ProductTransitions",
    ButtonData:>"ProductTransitions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ProductTransitions"],

Cell[TextData[{
  "   ",
  ButtonBox["QuotientDFA",
    ButtonData:>"QuotientDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"QuotientDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["QuotientMachineFA",
    ButtonData:>"QuotientMachineFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"QuotientMachineFA"],

Cell[TextData[{
  "   ",
  ButtonBox["RandomDFA",
    ButtonData:>"RandomDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RandomDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["RankOfDFA",
    ButtonData:>"RankOfDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RankOfDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["RankToDFA",
    ButtonData:>"RankToDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RankToDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["DeleteTransitionFA",
    ButtonData:>"DeleteTransitionFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeleteTransitionFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ReverseFA",
    ButtonData:>"ReverseFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ReverseFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SA",
    ButtonData:>"SA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SA"],

Cell[TextData[{
  "   ",
  ButtonBox["SelectFA",
    ButtonData:>"SelectFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SelectFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SetAlphabet",
    ButtonData:>"SetAlphabet",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SetAlphabet"],

Cell[TextData[{
  "   ",
  ButtonBox["SetFinalFA",
    ButtonData:>"SetFinalFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SetFinalFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SetInitialFA",
    ButtonData:>"SetInitialFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SetInitialFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SetInitialFinalFA",
    ButtonData:>"SetInitialFinalFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SetInitialFinalFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SetStates",
    ButtonData:>"SetStates",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SetStates"],

Cell[TextData[{
  "   ",
  ButtonBox["ShuffleProductFA",
    ButtonData:>"ShuffleProductFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ShuffleProductFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SinkQDFA",
    ButtonData:>"SinkQDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SinkQDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["Size",
    ButtonData:>"Size",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Size"],

Cell[TextData[{
  "   ",
  ButtonBox["SquareSA",
    ButtonData:>"SquareSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SquareSA"],

Cell[TextData[{
  "   ",
  ButtonBox["StarFA",
    ButtonData:>"StarFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"StarFA"],

Cell[TextData[{
  "   ",
  ButtonBox["StateMergeDFA",
    ButtonData:>"StateMergeDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"StateMergeDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["States",
    ButtonData:>"States",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"States"],

Cell[TextData[{
  "   ",
  ButtonBox["SubsetQFA",
    ButtonData:>"SubsetQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SubsetQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SubwordCounterDFA",
    ButtonData:>"SubwordCounterDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SubwordCounterDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SubwordDFA",
    ButtonData:>"SubwordDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SubwordDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SumFA",
    ButtonData:>"SumFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SumFA"],

Cell[TextData[{
  "   ",
  ButtonBox["SwitchTransitionFA",
    ButtonData:>"SwitchTransitionFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SwitchTransitionFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TheInitial",
    ButtonData:>"TheInitial",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TheInitial"],

Cell[TextData[{
  "   ",
  ButtonBox["ToCharacters",
    ButtonData:>"ToCharacters",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToCharacters"],

Cell[TextData[{
  "   ",
  ButtonBox["ToDFA",
    ButtonData:>"ToDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToEquationsDFA",
    ButtonData:>"ToEquationsDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToEquationsDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToFA",
    ButtonData:>"ToFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToFactorFA",
    ButtonData:>"ToFactorFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToFactorFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToFrontierDFA",
    ButtonData:>"ToFrontierDFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToFrontierDFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToGeneratorsFA",
    ButtonData:>"ToGeneratorsFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToGeneratorsFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToGraphFA",
    ButtonData:>"ToGraphFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToGraphFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToKernelFA",
    ButtonData:>"ToKernelFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToKernelFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToNFA",
    ButtonData:>"ToNFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToNFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToRegularExpressionFA",
    ButtonData:>"ToRegularExpressionFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToRegularExpressionFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToSA",
    ButtonData:>"ToSA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToSA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToSeries",
    ButtonData:>"ToSeries",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToSeries"],

Cell[TextData[{
  "   ",
  ButtonBox["ToTransitions",
    ButtonData:>"ToTransitions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToTransitions"],

Cell[TextData[{
  "   ",
  ButtonBox["TransferSequenceFA",
    ButtonData:>"TransferSequenceFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransferSequenceFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TransitionFunctionFA",
    ButtonData:>"TransitionFunctionFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransitionFunctionFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TransitionMatrixFA",
    ButtonData:>"TransitionMatrixFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransitionMatrixFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TransitionsToMatrix",
    ButtonData:>"TransitionsToMatrix",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransitionsToMatrix"],

Cell[TextData[{
  "   ",
  ButtonBox["Transitions",
    ButtonData:>"Transitions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Transitions"],

Cell[TextData[{
  "   ",
  ButtonBox["TransitiveLanguageQFA",
    ButtonData:>"TransitiveLanguageQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransitiveLanguageQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TransitiveQFA",
    ButtonData:>"TransitiveQFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransitiveQFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TrapStatesFA",
    ButtonData:>"TrapStatesFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TrapStatesFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TrimFA",
    ButtonData:>"TrimFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TrimFA"],

Cell[TextData[{
  "   ",
  ButtonBox["TropicalIdentityMatrix",
    ButtonData:>"TropicalIdentityMatrix",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TropicalIdentityMatrix"],

Cell[TextData[{
  "   ",
  ButtonBox["TS",
    ButtonData:>"TS",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TS"],

Cell[TextData[{
  "   ",
  ButtonBox["UnionFA",
    ButtonData:>"UnionFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"UnionFA"],

Cell[TextData[{
  "   ",
  ButtonBox["VerifyFA",
    ButtonData:>"VerifyFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"VerifyFA"],

Cell[TextData[{
  "   ",
  ButtonBox["WordToFA",
    ButtonData:>"WordToFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordToFA"],

Cell[TextData[{
  "   ",
  ButtonBox["ArdenSolve",
    ButtonData:>"ArdenSolve",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ArdenSolve"],

Cell[TextData[{
  "   ",
  ButtonBox["FormatX",
    ButtonData:>"FormatX",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FormatX"],

Cell[TextData[{
  "   ",
  ButtonBox["REEpsQ",
    ButtonData:>"REEpsQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"REEpsQ"],

Cell[TextData[{
  "   ",
  ButtonBox["RegularExpressionToBEFA",
    ButtonData:>"RegularExpressionToBEFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RegularExpressionToBEFA"],

Cell[TextData[{
  "   ",
  ButtonBox["RegularExpressionToFA",
    ButtonData:>"RegularExpressionToFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RegularExpressionToFA"],

Cell[TextData[{
  "   ",
  ButtonBox["RegularExpressionToNNFA",
    ButtonData:>"RegularExpressionToNNFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RegularExpressionToNNFA"],

Cell[TextData[{
  "   ",
  ButtonBox["REP",
    ButtonData:>"REP",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"REP"],

Cell[TextData[{
  "   ",
  ButtonBox["REQuotient",
    ButtonData:>"REQuotient",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"REQuotient"],

Cell[TextData[{
  "   ",
  ButtonBox["RES",
    ButtonData:>"RES",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RES"],

Cell[TextData[{
  "   ",
  ButtonBox["RESimplify",
    ButtonData:>"RESimplify",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RESimplify"],

Cell[TextData[{
  "   ",
  ButtonBox["RET",
    ButtonData:>"RET",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RET"],

Cell[TextData[{
  "   ",
  ButtonBox["SubstituteRE",
    ButtonData:>"SubstituteRE",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SubstituteRE"],

Cell[TextData[{
  "   ",
  ButtonBox["ToRegExp",
    ButtonData:>"ToRegExp",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToRegExp"],

Cell[TextData[{
  "   ",
  ButtonBox["BFunctionToCA",
    ButtonData:>"BFunctionToCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BFunctionToCA"],

Cell[TextData[{
  "   ",
  ButtonBox["CA",
    ButtonData:>"CA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CA"],

Cell[TextData[{
  "   ",
  ButtonBox["ClassifyCA",
    ButtonData:>"ClassifyCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ClassifyCA"],

Cell[TextData[{
  "   ",
  ButtonBox["ComposeCA",
    ButtonData:>"ComposeCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ComposeCA"],

Cell[TextData[{
  "   ",
  ButtonBox["EvolutionCA",
    ButtonData:>"EvolutionCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EvolutionCA"],

Cell[TextData[{
  "   ",
  ButtonBox["DependencyCA",
    ButtonData:>"DependencyCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DependencyCA"],

Cell[TextData[{
  "   ",
  ButtonBox["FSurjectiveCA",
    ButtonData:>"FSurjectiveCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FSurjectiveCA"],

Cell[TextData[{
  "   ",
  ButtonBox["FunctionToCA",
    ButtonData:>"FunctionToCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FunctionToCA"],

Cell[TextData[{
  "   ",
  ButtonBox["GlobalMapCA",
    ButtonData:>"GlobalMapCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GlobalMapCA"],

Cell[TextData[{
  "   ",
  ButtonBox["InverseCA",
    ButtonData:>"InverseCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"InverseCA"],

Cell[TextData[{
  "   ",
  ButtonBox["IterateCA",
    ButtonData:>"IterateCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IterateCA"],

Cell[TextData[{
  "   ",
  ButtonBox["LocalMapCA",
    ButtonData:>"LocalMapCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LocalMapCA"],

Cell[TextData[{
  "   ",
  ButtonBox["NumberOfCA",
    ButtonData:>"NumberOfCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NumberOfCA"],

Cell[TextData[{
  "   ",
  ButtonBox["NumberOfTotalisticCA",
    ButtonData:>"NumberOfTotalisticCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NumberOfTotalisticCA"],

Cell[TextData[{
  "   ",
  ButtonBox["OrbitCA",
    ButtonData:>"OrbitCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"OrbitCA"],

Cell[TextData[{
  "   ",
  ButtonBox["PolynomialToCA",
    ButtonData:>"PolynomialToCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PolynomialToCA"],

Cell[TextData[{
  "   ",
  ButtonBox["PrintCA",
    ButtonData:>"PrintCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PrintCA"],

Cell[TextData[{
  "   ",
  ButtonBox["RuleCA",
    ButtonData:>"RuleCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RuleCA"],

Cell[TextData[{
  "   ",
  ButtonBox["RulesToCA",
    ButtonData:>"RulesToCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RulesToCA"],

Cell[TextData[{
  "   ",
  ButtonBox["SeedConfiguration",
    ButtonData:>"SeedConfiguration",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SeedConfiguration"],

Cell[TextData[{
  "   ",
  ButtonBox["SimplifyCA",
    ButtonData:>"SimplifyCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SimplifyCA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToRulesCA",
    ButtonData:>"ToRulesCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToRulesCA"],

Cell[TextData[{
  "   ",
  ButtonBox["TotalisticRuleToCA",
    ButtonData:>"TotalisticRuleToCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TotalisticRuleToCA"],

Cell[TextData[{
  "   ",
  ButtonBox["ToTotalisticRuleCA",
    ButtonData:>"ToTotalisticRuleCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToTotalisticRuleCA"],

Cell[TextData[{
  "   ",
  ButtonBox["WelchCA",
    ButtonData:>"WelchCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WelchCA"],

Cell[TextData[{
  "   ",
  ButtonBox["WidthCA",
    ButtonData:>"WidthCA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WidthCA"],

Cell[TextData[{
  "   ",
  ButtonBox["AddEdge",
    ButtonData:>"AddEdge",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AddEdge"],

Cell[TextData[{
  "   ",
  ButtonBox["AddVertex",
    ButtonData:>"AddVertex",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AddVertex"],

Cell[TextData[{
  "   ",
  ButtonBox["BiAccessibleGraph",
    ButtonData:>"BiAccessibleGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BiAccessibleGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["AccessibleGraph",
    ButtonData:>"AccessibleGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AccessibleGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["CirculantGraph",
    ButtonData:>"CirculantGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CirculantGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["CyclicQGraph",
    ButtonData:>"CyclicQGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CyclicQGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["DeBruijnEdges",
    ButtonData:>"DeBruijnEdges",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeBruijnEdges"],

Cell[TextData[{
  "   ",
  ButtonBox["DeBruijnGraph",
    ButtonData:>"DeBruijnGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeBruijnGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["DegreeGraph",
    ButtonData:>"DegreeGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DegreeGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["DeleteEdge",
    ButtonData:>"DeleteEdge",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeleteEdge"],

Cell[TextData[{
  "   ",
  ButtonBox["DeleteVertex",
    ButtonData:>"DeleteVertex",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeleteVertex"],

Cell[TextData[{
  "   ",
  ButtonBox["EdgeQ",
    ButtonData:>"EdgeQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EdgeQ"],

Cell[TextData[{
  "   ",
  ButtonBox["Edges",
    ButtonData:>"Edges",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Edges"],

Cell[TextData[{
  "   ",
  ButtonBox["Graph",
    ButtonData:>"Graph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Graph"],

Cell[TextData[{
  "   ",
  ButtonBox["GridGraph",
    ButtonData:>"GridGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GridGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["LabelEdgeList",
    ButtonData:>"LabelEdgeList",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LabelEdgeList"],

Cell[TextData[{
  "   ",
  ButtonBox["LongestPath",
    ButtonData:>"LongestPath",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LongestPath"],

Cell[TextData[{
  "   ",
  ButtonBox["NormalizeGraph",
    ButtonData:>"NormalizeGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NormalizeGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["NonTransientGraph",
    ButtonData:>"NonTransientGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NonTransientGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["NumEdges",
    ButtonData:>"NumEdges",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NumEdges"],

Cell[TextData[{
  "   ",
  ButtonBox["NumVertices",
    ButtonData:>"NumVertices",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NumVertices"],

Cell[TextData[{
  "   ",
  ButtonBox["PathGraph",
    ButtonData:>"PathGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PathGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["PermuteGraph",
    ButtonData:>"PermuteGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PermuteGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["ProductGraph",
    ButtonData:>"ProductGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ProductGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["ProductLabeledGraph",
    ButtonData:>"ProductLabeledGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ProductLabeledGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["ReverseGraph",
    ButtonData:>"ReverseGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ReverseGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["SetVertices",
    ButtonData:>"SetVertices",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SetVertices"],

Cell[TextData[{
  "   ",
  ButtonBox["ShortestPath",
    ButtonData:>"ShortestPath",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ShortestPath"],

Cell[TextData[{
  "   ",
  ButtonBox["StronglyConnectedComponents",
    ButtonData:>"StronglyConnectedComponents",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"StronglyConnectedComponents"],

Cell[TextData[{
  "   ",
  ButtonBox["SubGraph",
    ButtonData:>"SubGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SubGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["ToAdjacencyList",
    ButtonData:>"ToAdjacencyList",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToAdjacencyList"],

Cell[TextData[{
  "   ",
  ButtonBox["ToAdjacencyMatrix",
    ButtonData:>"ToAdjacencyMatrix",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToAdjacencyMatrix"],

Cell[TextData[{
  "   ",
  ButtonBox["ToDirectedAcyclicGraph",
    ButtonData:>"ToDirectedAcyclicGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToDirectedAcyclicGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["ToEdgeList",
    ButtonData:>"ToEdgeList",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToEdgeList"],

Cell[TextData[{
  "   ",
  ButtonBox["ToTDGraph",
    ButtonData:>"ToTDGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToTDGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["TypeGraph",
    ButtonData:>"TypeGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TypeGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["VertexSet",
    ButtonData:>"VertexSet",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"VertexSet"],

Cell[TextData[{
  "   ",
  ButtonBox["WeaklyConnectedComponents",
    ButtonData:>"WeaklyConnectedComponents",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WeaklyConnectedComponents"],

Cell[TextData[{
  "   ",
  ButtonBox["AllTimes",
    ButtonData:>"AllTimes",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AllTimes"],

Cell[TextData[{
  "   ",
  ButtonBox["AperiodicQSG",
    ButtonData:>"AperiodicQSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AperiodicQSG"],

Cell[TextData[{
  "   ",
  ButtonBox["AperiodicSG",
    ButtonData:>"AperiodicSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AperiodicSG"],

Cell[TextData[{
  "   ",
  ButtonBox["BlocksToDClass",
    ButtonData:>"BlocksToDClass",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BlocksToDClass"],

Cell[TextData[{
  "   ",
  ButtonBox["CollapseT",
    ButtonData:>"CollapseT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CollapseT"],

Cell[TextData[{
  "   ",
  ButtonBox["ConstantT",
    ButtonData:>"ConstantT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ConstantT"],

Cell[TextData[{
  "   ",
  ButtonBox["CycleDecompositionT",
    ButtonData:>"CycleDecompositionT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CycleDecompositionT"],

Cell[TextData[{
  "   ",
  ButtonBox["CycleToT",
    ButtonData:>"CycleToT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CycleToT"],

Cell[TextData[{
  "   ",
  ButtonBox["DC",
    ButtonData:>"DC",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DC"],

Cell[TextData[{
  "   ",
  ButtonBox["DClassDecomposition",
    ButtonData:>"DClassDecomposition",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DClassDecomposition"],

Cell[TextData[{
  "   ",
  ButtonBox["DClassSize",
    ButtonData:>"DClassSize",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DClassSize"],

Cell[TextData[{
  "   ",
  ButtonBox["DClassT",
    ButtonData:>"DClassT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DClassT"],

Cell[TextData[{
  "   ",
  ButtonBox["DClassToBlocks",
    ButtonData:>"DClassToBlocks",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DClassToBlocks"],

Cell[TextData[{
  "   ",
  ButtonBox["DihedralGroupSG",
    ButtonData:>"DihedralGroupSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DihedralGroupSG"],

Cell[TextData[{
  "   ",
  ButtonBox["GEN",
    ButtonData:>"GEN",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GEN"],

Cell[TextData[{
  "   ",
  ButtonBox["GenerateCSM",
    ButtonData:>"GenerateCSM",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GenerateCSM"],

Cell[TextData[{
  "   ",
  ButtonBox["GenerateCayleyGraph",
    ButtonData:>"GenerateCayleyGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GenerateCayleyGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["GenerateSG",
    ButtonData:>"GenerateSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GenerateSG"],

Cell[TextData[{
  "   ",
  ButtonBox["GreenHQT",
    ButtonData:>"GreenHQT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GreenHQT"],

Cell[TextData[{
  "   ",
  ButtonBox["GreenJQT",
    ButtonData:>"GreenJQT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GreenJQT"],

Cell[TextData[{
  "   ",
  ButtonBox["GreenLQT",
    ButtonData:>"GreenLQT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GreenLQT"],

Cell[TextData[{
  "   ",
  ButtonBox["GreenRQT",
    ButtonData:>"GreenRQT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GreenRQT"],

Cell[TextData[{
  "   ",
  ButtonBox["HClassSize",
    ButtonData:>"HClassSize",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"HClassSize"],

Cell[TextData[{
  "   ",
  ButtonBox["HClassT",
    ButtonData:>"HClassT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"HClassT"],

Cell[TextData[{
  "   ",
  ButtonBox["HTrivialQSG",
    ButtonData:>"HTrivialQSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"HTrivialQSG"],

Cell[TextData[{
  "   ",
  ButtonBox["IdealT",
    ButtonData:>"IdealT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IdealT"],

Cell[TextData[{
  "   ",
  ButtonBox["IdemSG",
    ButtonData:>"IdemSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IdemSG"],

Cell[TextData[{
  "   ",
  ButtonBox["ImageT",
    ButtonData:>"ImageT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ImageT"],

Cell[TextData[{
  "   ",
  ButtonBox["InGroupSG",
    ButtonData:>"InGroupSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"InGroupSG"],

Cell[TextData[{
  "   ",
  ButtonBox["InverseT",
    ButtonData:>"InverseT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"InverseT"],

Cell[TextData[{
  "   ",
  ButtonBox["JTrivialQSG",
    ButtonData:>"JTrivialQSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"JTrivialQSG"],

Cell[TextData[{
  "   ",
  ButtonBox["JTrivialSG",
    ButtonData:>"JTrivialSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"JTrivialSG"],

Cell[TextData[{
  "   ",
  ButtonBox["KernelImageToT",
    ButtonData:>"KernelImageToT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"KernelImageToT"],

Cell[TextData[{
  "   ",
  ButtonBox["KernelT",
    ButtonData:>"KernelT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"KernelT"],

Cell[TextData[{
  "   ",
  ButtonBox["LeftIdealT",
    ButtonData:>"LeftIdealT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LeftIdealT"],

Cell[TextData[{
  "   ",
  ButtonBox["LeftNullSG",
    ButtonData:>"LeftNullSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LeftNullSG"],

Cell[TextData[{
  "   ",
  ButtonBox["LeftOneSG",
    ButtonData:>"LeftOneSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LeftOneSG"],

Cell[TextData[{
  "   ",
  ButtonBox["LocallyCommutativeQSG",
    ButtonData:>"LocallyCommutativeQSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LocallyCommutativeQSG"],

Cell[TextData[{
  "   ",
  ButtonBox["LocallyIdempotentQSG",
    ButtonData:>"LocallyIdempotentQSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LocallyIdempotentQSG"],

Cell[TextData[{
  "   ",
  ButtonBox["Merge12T",
    ButtonData:>"Merge12T",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Merge12T"],

Cell[TextData[{
  "   ",
  ButtonBox["MakeMonoidSG",
    ButtonData:>"MakeMonoidSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MakeMonoidSG"],

Cell[TextData[{
  "   ",
  ButtonBox["MonoidQSG",
    ButtonData:>"MonoidQSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MonoidQSG"],

Cell[TextData[{
  "   ",
  ButtonBox["NilpotentQSG",
    ButtonData:>"NilpotentQSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NilpotentQSG"],

Cell[TextData[{
  "   ",
  ButtonBox["NullSG",
    ButtonData:>"NullSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NullSG"],

Cell[TextData[{
  "   ",
  ButtonBox["OneSG",
    ButtonData:>"OneSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"OneSG"],

Cell[TextData[{
  "   ",
  ButtonBox["OneT",
    ButtonData:>"OneT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"OneT"],

Cell[TextData[{
  "   ",
  ButtonBox["OrderT",
    ButtonData:>"OrderT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"OrderT"],

Cell[TextData[{
  "   ",
  ButtonBox["PrintDClass",
    ButtonData:>"PrintDClass",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PrintDClass"],

Cell[TextData[{
  "   ",
  ButtonBox["PrintEquations",
    ButtonData:>"PrintEquations",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PrintEquations"],

Cell[TextData[{
  "   ",
  ButtonBox["PrintWitnesses",
    ButtonData:>"PrintWitnesses",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PrintWitnesses"],

Cell[TextData[{
  "   ",
  ButtonBox["RegularSG",
    ButtonData:>"RegularSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RegularSG"],

Cell[TextData[{
  "   ",
  ButtonBox["RandomT",
    ButtonData:>"RandomT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RandomT"],

Cell[TextData[{
  "   ",
  ButtonBox["RankT",
    ButtonData:>"RankT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RankT"],

Cell[TextData[{
  "   ",
  ButtonBox["RightIdealT",
    ButtonData:>"RightIdealT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RightIdealT"],

Cell[TextData[{
  "   ",
  ButtonBox["RightNullSG",
    ButtonData:>"RightNullSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RightNullSG"],

Cell[TextData[{
  "   ",
  ButtonBox["RightOneSG",
    ButtonData:>"RightOneSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RightOneSG"],

Cell[TextData[{
  "   ",
  ButtonBox["ShiftT",
    ButtonData:>"ShiftT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ShiftT"],

Cell[TextData[{
  "   ",
  ButtonBox["SG",
    ButtonData:>"SG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SG"],

Cell[TextData[{
  "   ",
  ButtonBox["SolveSG",
    ButtonData:>"SolveSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SolveSG"],

Cell[TextData[{
  "   ",
  ButtonBox["SymmetricGroupSG",
    ButtonData:>"SymmetricGroupSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SymmetricGroupSG"],

Cell[TextData[{
  "   ",
  ButtonBox["SyntacticCongruence",
    ButtonData:>"SyntacticCongruence",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SyntacticCongruence"],

Cell[TextData[{
  "   ",
  ButtonBox["SyntacticHomomorphism",
    ButtonData:>"SyntacticHomomorphism",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SyntacticHomomorphism"],

Cell[TextData[{
  "   ",
  ButtonBox["SyntacticSG",
    ButtonData:>"SyntacticSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SyntacticSG"],

Cell[TextData[{
  "   ",
  ButtonBox["T",
    ButtonData:>"T",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"T"],

Cell[TextData[{
  "   ",
  ButtonBox["TableSG",
    ButtonData:>"TableSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TableSG"],

Cell[TextData[{
  "   ",
  ButtonBox["ToIdentityString",
    ButtonData:>"ToIdentityString",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToIdentityString"],

Cell[TextData[{
  "   ",
  ButtonBox["TransformationSG",
    ButtonData:>"TransformationSG",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransformationSG"],

Cell[TextData[{
  "   ",
  ButtonBox["TransientPeriodicT",
    ButtonData:>"TransientPeriodicT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransientPeriodicT"],

Cell[TextData[{
  "   ",
  ButtonBox["TranspositionT",
    ButtonData:>"TranspositionT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TranspositionT"],

Cell[TextData[{
  "   ",
  ButtonBox["UnitElement",
    ButtonData:>"UnitElement",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"UnitElement"],

Cell[TextData[{
  "   ",
  ButtonBox["EquationsToWitnesses",
    ButtonData:>"EquationsToWitnesses",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EquationsToWitnesses"],

Cell[TextData[{
  "   ",
  ButtonBox["FromIdentityString",
    ButtonData:>"FromIdentityString",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FromIdentityString"],

Cell[TextData[{
  "   ",
  ButtonBox["IrreducibleQ",
    ButtonData:>"IrreducibleQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"IrreducibleQ"],

Cell[TextData[{
  "   ",
  ButtonBox["PairsToRules",
    ButtonData:>"PairsToRules",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PairsToRules"],

Cell[TextData[{
  "   ",
  ButtonBox["RulesToPairs",
    ButtonData:>"RulesToPairs",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RulesToPairs"],

Cell[TextData[{
  "   ",
  ButtonBox["SimplifyEquations",
    ButtonData:>"SimplifyEquations",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SimplifyEquations"],

Cell[TextData[{
  "   ",
  ButtonBox["SimplifyRewriteSystem",
    ButtonData:>"SimplifyRewriteSystem",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SimplifyRewriteSystem"],

Cell[TextData[{
  "   ",
  ButtonBox["WordReduce",
    ButtonData:>"WordReduce",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"WordReduce"],

Cell[TextData[{
  "   ",
  ButtonBox["BooleanComplement",
    ButtonData:>"BooleanComplement",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BooleanComplement"],

Cell[TextData[{
  "   ",
  ButtonBox["BooleanComposition",
    ButtonData:>"BooleanComposition",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BooleanComposition"],

Cell[TextData[{
  "   ",
  ButtonBox["BooleanConverse",
    ButtonData:>"BooleanConverse",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BooleanConverse"],

Cell[TextData[{
  "   ",
  ButtonBox["BooleanIntersection",
    ButtonData:>"BooleanIntersection",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BooleanIntersection"],

Cell[TextData[{
  "   ",
  ButtonBox["BooleanPower",
    ButtonData:>"BooleanPower",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BooleanPower"],

Cell[TextData[{
  "   ",
  ButtonBox["BooleanUnion",
    ButtonData:>"BooleanUnion",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"BooleanUnion"],

Cell[TextData[{
  "   ",
  ButtonBox["RelationToMatrix",
    ButtonData:>"RelationToMatrix",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RelationToMatrix"],

Cell[TextData[{
  "   ",
  ButtonBox["ToClasses",
    ButtonData:>"ToClasses",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToClasses"],

Cell[TextData[{
  "   ",
  ButtonBox["TransitiveClosure",
    ButtonData:>"TransitiveClosure",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransitiveClosure"],

Cell[TextData[{
  "   ",
  ButtonBox["Warshall",
    ButtonData:>"Warshall",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Warshall"],

Cell[TextData[{
  "   ",
  ButtonBox["AnalyzeOrbit",
    ButtonData:>"AnalyzeOrbit",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AnalyzeOrbit"],

Cell[TextData[{
  "   ",
  ButtonBox["CartesianProduct",
    ButtonData:>"CartesianProduct",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CartesianProduct"],

Cell[TextData[{
  "   ",
  ButtonBox["ClosureSearch",
    ButtonData:>"ClosureSearch",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ClosureSearch"],

Cell[TextData[{
  "   ",
  ButtonBox["Closure",
    ButtonData:>"Closure",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Closure"],

Cell[TextData[{
  "   ",
  ButtonBox["DeleteDuplicates",
    ButtonData:>"DeleteDuplicates",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DeleteDuplicates"],

Cell[TextData[{
  "   ",
  ButtonBox["DisjointQ",
    ButtonData:>"DisjointQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DisjointQ"],

Cell[TextData[{
  "   ",
  ButtonBox["EnumForm",
    ButtonData:>"EnumForm",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"EnumForm"],

Cell[TextData[{
  "   ",
  ButtonBox["FastPowerSet",
    ButtonData:>"FastPowerSet",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FastPowerSet"],

Cell[TextData[{
  "   ",
  ButtonBox["Frequencies",
    ButtonData:>"Frequencies",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Frequencies"],

Cell[TextData[{
  "   ",
  ButtonBox["FromBitVector",
    ButtonData:>"FromBitVector",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FromBitVector"],

Cell[TextData[{
  "   ",
  ButtonBox["LongestCommonSubsequence",
    ButtonData:>"LongestCommonSubsequence",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"LongestCommonSubsequence"],

Cell[TextData[{
  "   ",
  ButtonBox["MakeIndex",
    ButtonData:>"MakeIndex",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MakeIndex"],

Cell[TextData[{
  "   ",
  ButtonBox["NonDecreasingSequences",
    ButtonData:>"NonDecreasingSequences",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NonDecreasingSequences"],

Cell[TextData[{
  "   ",
  ButtonBox["Pairs",
    ButtonData:>"Pairs",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Pairs"],

Cell[TextData[{
  "   ",
  ButtonBox["Partitions",
    ButtonData:>"Partitions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Partitions"],

Cell[TextData[{
  "   ",
  ButtonBox["PowerSet",
    ButtonData:>"PowerSet",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PowerSet"],

Cell[TextData[{
  "   ",
  ButtonBox["RandomPermutation",
    ButtonData:>"RandomPermutation",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RandomPermutation"],

Cell[TextData[{
  "   ",
  ButtonBox["RankingRules",
    ButtonData:>"RankingRules",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RankingRules"],

Cell[TextData[{
  "   ",
  ButtonBox["RootList",
    ButtonData:>"RootList",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"RootList"],

Cell[TextData[{
  "   ",
  ButtonBox["SelectorQ",
    ButtonData:>"SelectorQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SelectorQ"],

Cell[TextData[{
  "   ",
  ButtonBox["Shuffle",
    ButtonData:>"Shuffle",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Shuffle"],

Cell[TextData[{
  "   ",
  ButtonBox["SubsetQ",
    ButtonData:>"SubsetQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SubsetQ"],

Cell[TextData[{
  "   ",
  ButtonBox["ToBitVector",
    ButtonData:>"ToBitVector",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToBitVector"],

Cell[TextData[{
  "   ",
  ButtonBox["ToList",
    ButtonData:>"ToList",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToList"],

Cell[TextData[{
  "   ",
  ButtonBox["ToPairs",
    ButtonData:>"ToPairs",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ToPairs"],

Cell[TextData[{
  "   ",
  ButtonBox["Tuples",
    ButtonData:>"Tuples",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Tuples"],

Cell[TextData[{
  "   ",
  ButtonBox["AssignFunction",
    ButtonData:>"AssignFunction",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AssignFunction"],

Cell[TextData[{
  "   ",
  ButtonBox["Curry",
    ButtonData:>"Curry",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Curry"],

Cell[TextData[{
  "   ",
  ButtonBox["Dependency",
    ButtonData:>"Dependency",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Dependency"],

Cell[TextData[{
  "   ",
  ButtonBox["ExtAutomata",
    ButtonData:>"ExtAutomata",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ExtAutomata"],

Cell[TextData[{
  "   ",
  ButtonBox["FlattenOne",
    ButtonData:>"FlattenOne",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FlattenOne"],

Cell[TextData[{
  "   ",
  ButtonBox["FormatAutomata",
    ButtonData:>"FormatAutomata",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FormatAutomata"],

Cell[TextData[{
  "   ",
  ButtonBox["PositionList",
    ButtonData:>"PositionList",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PositionList"],

Cell[TextData[{
  "   ",
  ButtonBox["PositionOne",
    ButtonData:>"PositionOne",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PositionOne"],

Cell[TextData[{
  "   ",
  ButtonBox["ReplaceParts",
    ButtonData:>"ReplaceParts",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ReplaceParts"],

Cell[TextData[{
  "   ",
  ButtonBox["SelectOptions",
    ButtonData:>"SelectOptions",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SelectOptions"],

Cell[TextData[{
  "   ",
  ButtonBox["Status",
    ButtonData:>"Status",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Status"],

Cell[TextData[{
  "   ",
  ButtonBox["SymbolList",
    ButtonData:>"SymbolList",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SymbolList"],

Cell[TextData[{
  "   ",
  ButtonBox["PostLoad",
    ButtonData:>"PostLoad",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PostLoad"],

Cell[TextData[{
  "   ",
  ButtonBox["PreLoad",
    ButtonData:>"PreLoad",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PreLoad"],

Cell[TextData[{
  "   ",
  ButtonBox["ColorQ",
    ButtonData:>"ColorQ",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ColorQ"],

Cell[TextData[{
  "   ",
  ButtonBox["DoShow",
    ButtonData:>"DoShow",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DoShow"],

Cell[TextData[{
  "   ",
  ButtonBox["GridLine",
    ButtonData:>"GridLine",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GridLine"],

Cell[TextData[{
  "   ",
  ButtonBox["GridPoints",
    ButtonData:>"GridPoints",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"GridPoints"],

Cell[TextData[{
  "   ",
  ButtonBox["HueRasterColors",
    ButtonData:>"HueRasterColors",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"HueRasterColors"],

Cell[TextData[{
  "   ",
  ButtonBox["MakePlotRange",
    ButtonData:>"MakePlotRange",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"MakePlotRange"],

Cell[TextData[{
  "   ",
  ButtonBox["PlotComputationFA",
    ButtonData:>"PlotComputationFA",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PlotComputationFA"],

Cell[TextData[{
  "   ",
  ButtonBox["PlotFunction",
    ButtonData:>"PlotFunction",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PlotFunction"],

Cell[TextData[{
  "   ",
  ButtonBox["PlotMatrix",
    ButtonData:>"PlotMatrix",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PlotMatrix"],

Cell[TextData[{
  "   ",
  ButtonBox["PlotRelation",
    ButtonData:>"PlotRelation",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PlotRelation"],

Cell[TextData[{
  "   ",
  ButtonBox["PlotTDGraph",
    ButtonData:>"PlotTDGraph",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PlotTDGraph"],

Cell[TextData[{
  "   ",
  ButtonBox["PlotT",
    ButtonData:>"PlotT",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PlotT"],

Cell[TextData[{
  "   ",
  ButtonBox["ShowArray",
    ButtonData:>"ShowArray",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ShowArray"],

Cell[TextData[{
  "   ",
  ButtonBox["StaircasePlot",
    ButtonData:>"StaircasePlot",
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"StaircasePlot"]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
WindowSize->{520, 600},
WindowMargins->{{380, Automatic}, {Automatic, 212}},
Visible->False,
LanguageCategory->"Mathematica",
Magnification->1,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "MasterIndexHeading"->{
    Cell[1754, 51, 66, 1, 41, "IndexSection",
      CellTags->"MasterIndexHeading"]},
  "AlgebraicForm"->{
    Cell[1823, 54, 159, 6, 16, "Index",
      CellTags->"AlgebraicForm"]},
  "Alphabet"->{
    Cell[1985, 62, 144, 6, 16, "Index",
      CellTags->"Alphabet"]},
  "AlphabetQ"->{
    Cell[2132, 70, 147, 6, 16, "Index",
      CellTags->"AlphabetQ"]},
  "AlphabetSize"->{
    Cell[2282, 78, 156, 6, 16, "Index",
      CellTags->"AlphabetSize"]},
  "Concatenate"->{
    Cell[2441, 86, 153, 6, 16, "Index",
      CellTags->"Concatenate"]},
  "Eps"->{
    Cell[2597, 94, 129, 6, 16, "Index",
      CellTags->"Eps"]},
  "FromEps"->{
    Cell[2729, 102, 141, 6, 16, "Index",
      CellTags->"FromEps"]},
  "FromFrontier"->{
    Cell[2873, 110, 156, 6, 16, "Index",
      CellTags->"FromFrontier"]},
  "FrontierQ"->{
    Cell[3032, 118, 147, 6, 16, "Index",
      CellTags->"FrontierQ"]},
  "MakeAlphabet"->{
    Cell[3182, 126, 156, 6, 16, "Index",
      CellTags->"MakeAlphabet"]},
  "MakeWord"->{
    Cell[3341, 134, 144, 6, 16, "Index",
      CellTags->"MakeWord"]},
  "ParikhVector"->{
    Cell[3488, 142, 156, 6, 16, "Index",
      CellTags->"ParikhVector"]},
  "RandomWord"->{
    Cell[3647, 150, 150, 6, 16, "Index",
      CellTags->"RandomWord"]},
  "ToBlocks"->{
    Cell[3800, 158, 144, 6, 16, "Index",
      CellTags->"ToBlocks"]},
  "ToEps"->{
    Cell[3947, 166, 135, 6, 16, "Index",
      CellTags->"ToEps"]},
  "ToFrontier"->{
    Cell[4085, 174, 150, 6, 16, "Index",
      CellTags->"ToFrontier"]},
  "ToIndex"->{
    Cell[4238, 182, 141, 6, 16, "Index",
      CellTags->"ToIndex"]},
  "ToWord"->{
    Cell[4382, 190, 138, 6, 16, "Index",
      CellTags->"ToWord"]},
  "WordBinomial"->{
    Cell[4523, 198, 156, 6, 16, "Index",
      CellTags->"WordBinomial"]},
  "WordConjugateQ"->{
    Cell[4682, 206, 162, 6, 16, "Index",
      CellTags->"WordConjugateQ"]},
  "WordConjugates"->{
    Cell[4847, 214, 162, 6, 16, "Index",
      CellTags->"WordConjugates"]},
  "WordFactorizations"->{
    Cell[5012, 222, 174, 6, 16, "Index",
      CellTags->"WordFactorizations"]},
  "WordFactorQ"->{
    Cell[5189, 230, 153, 6, 16, "Index",
      CellTags->"WordFactorQ"]},
  "WordFactors"->{
    Cell[5345, 238, 153, 6, 16, "Index",
      CellTags->"WordFactors"]},
  "WordFusion"->{
    Cell[5501, 246, 150, 6, 16, "Index",
      CellTags->"WordFusion"]},
  "WordLength"->{
    Cell[5654, 254, 150, 6, 16, "Index",
      CellTags->"WordLength"]},
  "WordOrder"->{
    Cell[5807, 262, 147, 6, 16, "Index",
      CellTags->"WordOrder"]},
  "WordPeriod"->{
    Cell[5957, 270, 150, 6, 16, "Index",
      CellTags->"WordPeriod"]},
  "WordPower"->{
    Cell[6110, 278, 147, 6, 16, "Index",
      CellTags->"WordPower"]},
  "WordPrefixQ"->{
    Cell[6260, 286, 153, 6, 16, "Index",
      CellTags->"WordPrefixQ"]},
  "WordPrefixes"->{
    Cell[6416, 294, 156, 6, 16, "Index",
      CellTags->"WordPrefixes"]},
  "WordPrimitiveCount"->{
    Cell[6575, 302, 174, 6, 16, "Index",
      CellTags->"WordPrimitiveCount"]},
  "WordPrimitiveQ"->{
    Cell[6752, 310, 162, 6, 16, "Index",
      CellTags->"WordPrimitiveQ"]},
  "WordQ"->{
    Cell[6917, 318, 135, 6, 16, "Index",
      CellTags->"WordQ"]},
  "WordReverse"->{
    Cell[7055, 326, 153, 6, 16, "Index",
      CellTags->"WordReverse"]},
  "WordRoot"->{
    Cell[7211, 334, 144, 6, 16, "Index",
      CellTags->"WordRoot"]},
  "WordRotate"->{
    Cell[7358, 342, 150, 6, 16, "Index",
      CellTags->"WordRotate"]},
  "Words"->{
    Cell[7511, 350, 135, 6, 16, "Index",
      CellTags->"Words"]},
  "WordShuffle"->{
    Cell[7649, 358, 153, 6, 16, "Index",
      CellTags->"WordShuffle"]},
  "WordSort"->{
    Cell[7805, 366, 144, 6, 16, "Index",
      CellTags->"WordSort"]},
  "WordSuffixQ"->{
    Cell[7952, 374, 153, 6, 16, "Index",
      CellTags->"WordSuffixQ"]},
  "WordSuffixes"->{
    Cell[8108, 382, 156, 6, 16, "Index",
      CellTags->"WordSuffixes"]},
  "AcceptQFA"->{
    Cell[8267, 390, 147, 6, 16, "Index",
      CellTags->"AcceptQFA"]},
  "AccessibleFA"->{
    Cell[8417, 398, 156, 6, 16, "Index",
      CellTags->"AccessibleFA"]},
  "AddTransitionFA"->{
    Cell[8576, 406, 165, 6, 16, "Index",
      CellTags->"AddTransitionFA"]},
  "AllDFA"->{
    Cell[8744, 414, 138, 6, 16, "Index",
      CellTags->"AllDFA"]},
  "AmbiguousQFA"->{
    Cell[8885, 422, 156, 6, 16, "Index",
      CellTags->"AmbiguousQFA"]},
  "BEFA"->{
    Cell[9044, 430, 132, 6, 16, "Index",
      CellTags->"BEFA"]},
  "BEFAToFA"->{
    Cell[9179, 438, 144, 6, 16, "Index",
      CellTags->"BEFAToFA"]},
  "BehaviorFA"->{
    Cell[9326, 446, 150, 6, 16, "Index",
      CellTags->"BehaviorFA"]},
  "BuildBEFA"->{
    Cell[9479, 454, 147, 6, 16, "Index",
      CellTags->"BuildBEFA"]},
  "BuildDFA"->{
    Cell[9629, 462, 144, 6, 16, "Index",
      CellTags->"BuildDFA"]},
  "BuildNNFA"->{
    Cell[9776, 470, 147, 6, 16, "Index",
      CellTags->"BuildNNFA"]},
  "BuildStarDFA"->{
    Cell[9926, 478, 156, 6, 16, "Index",
      CellTags->"BuildStarDFA"]},
  "CirculantSA"->{
    Cell[10085, 486, 153, 6, 16, "Index",
      CellTags->"CirculantSA"]},
  "CoAccessibleFA"->{
    Cell[10241, 494, 162, 6, 16, "Index",
      CellTags->"CoAccessibleFA"]},
  "ComplementFA"->{
    Cell[10406, 502, 156, 6, 16, "Index",
      CellTags->"ComplementFA"]},
  "CompleteFA"->{
    Cell[10565, 510, 150, 6, 16, "Index",
      CellTags->"CompleteFA"]},
  "CompleteQFA"->{
    Cell[10718, 518, 153, 6, 16, "Index",
      CellTags->"CompleteQFA"]},
  "ComputationFA"->{
    Cell[10874, 526, 159, 6, 16, "Index",
      CellTags->"ComputationFA"]},
  "ComputationGraphFA"->{
    Cell[11036, 534, 174, 6, 16, "Index",
      CellTags->"ComputationGraphFA"]},
  "ConcatenateFA"->{
    Cell[11213, 542, 159, 6, 16, "Index",
      CellTags->"ConcatenateFA"]},
  "ConvertToFA"->{
    Cell[11375, 550, 153, 6, 16, "Index",
      CellTags->"ConvertToFA"]},
  "CounterDFA"->{
    Cell[11531, 558, 150, 6, 16, "Index",
      CellTags->"CounterDFA"]},
  "CoverQDFA"->{
    Cell[11684, 566, 147, 6, 16, "Index",
      CellTags->"CoverQDFA"]},
  "DefiniteQFA"->{
    Cell[11834, 574, 153, 6, 16, "Index",
      CellTags->"DefiniteQFA"]},
  "DegreesFA"->{
    Cell[11990, 582, 147, 6, 16, "Index",
      CellTags->"DegreesFA"]},
  "DeleteStateFA"->{
    Cell[12140, 590, 159, 6, 16, "Index",
      CellTags->"DeleteStateFA"]},
  "DeterministicQFA"->{
    Cell[12302, 598, 168, 6, 16, "Index",
      CellTags->"DeterministicQFA"]},
  "DFA"->{
    Cell[12473, 606, 129, 6, 16, "Index",
      CellTags->"DFA"]},
  "DivisibilityDFA"->{
    Cell[12605, 614, 165, 6, 16, "Index",
      CellTags->"DivisibilityDFA"]},
  "EmptyDFA"->{
    Cell[12773, 622, 144, 6, 16, "Index",
      CellTags->"EmptyDFA"]},
  "EmptyQFA"->{
    Cell[12920, 630, 144, 6, 16, "Index",
      CellTags->"EmptyQFA"]},
  "EpsilonFreeQ"->{
    Cell[13067, 638, 156, 6, 16, "Index",
      CellTags->"EpsilonFreeQ"]},
  "EpsilonEliminationFA"->{
    Cell[13226, 646, 180, 6, 16, "Index",
      CellTags->"EpsilonEliminationFA"]},
  "EquivalentQFA"->{
    Cell[13409, 654, 159, 6, 16, "Index",
      CellTags->"EquivalentQFA"]},
  "FactorialQFA"->{
    Cell[13571, 662, 156, 6, 16, "Index",
      CellTags->"FactorialQFA"]},
  "FA"->{
    Cell[13730, 670, 126, 6, 16, "Index",
      CellTags->"FA"]},
  "FinalVectorFA"->{
    Cell[13859, 678, 159, 6, 16, "Index",
      CellTags->"FinalVectorFA"]},
  "Final"->{
    Cell[14021, 686, 135, 6, 16, "Index",
      CellTags->"Final"]},
  "FiniteComplementSA"->{
    Cell[14159, 694, 174, 6, 16, "Index",
      CellTags->"FiniteComplementSA"]},
  "FrontierToDFA"->{
    Cell[14336, 702, 159, 6, 16, "Index",
      CellTags->"FrontierToDFA"]},
  "FSMQ"->{
    Cell[14498, 710, 132, 6, 16, "Index",
      CellTags->"FSMQ"]},
  "FullQFA"->{
    Cell[14633, 718, 141, 6, 16, "Index",
      CellTags->"FullQFA"]},
  "FullTransitionMatrixFA"->{
    Cell[14777, 726, 186, 6, 16, "Index",
      CellTags->"FullTransitionMatrixFA"]},
  "FullTransitions"->{
    Cell[14966, 734, 165, 6, 16, "Index",
      CellTags->"FullTransitions"]},
  "FunctionToDFA"->{
    Cell[15134, 742, 159, 6, 16, "Index",
      CellTags->"FunctionToDFA"]},
  "FunctionToSA"->{
    Cell[15296, 750, 156, 6, 16, "Index",
      CellTags->"FunctionToSA"]},
  "GenerateDFA"->{
    Cell[15455, 758, 153, 6, 16, "Index",
      CellTags->"GenerateDFA"]},
  "GenerateQuotients"->{
    Cell[15611, 766, 171, 6, 16, "Index",
      CellTags->"GenerateQuotients"]},
  "GrowthSeriesDFA"->{
    Cell[15785, 774, 165, 6, 16, "Index",
      CellTags->"GrowthSeriesDFA"]},
  "HomomorphismFA"->{
    Cell[15953, 782, 162, 6, 16, "Index",
      CellTags->"HomomorphismFA"]},
  "HurwitzProduct"->{
    Cell[16118, 790, 162, 6, 16, "Index",
      CellTags->"HurwitzProduct"]},
  "IdealBaseFA"->{
    Cell[16283, 798, 153, 6, 16, "Index",
      CellTags->"IdealBaseFA"]},
  "IdealQFA"->{
    Cell[16439, 806, 144, 6, 16, "Index",
      CellTags->"IdealQFA"]},
  "InfiniteQFA"->{
    Cell[16586, 814, 153, 6, 16, "Index",
      CellTags->"InfiniteQFA"]},
  "InitialVectorFA"->{
    Cell[16742, 822, 165, 6, 16, "Index",
      CellTags->"InitialVectorFA"]},
  "Initial"->{
    Cell[16910, 830, 141, 6, 16, "Index",
      CellTags->"Initial"]},
  "IntersectionFA"->{
    Cell[17054, 838, 162, 6, 16, "Index",
      CellTags->"IntersectionFA"]},
  "IrreducibleFA"->{
    Cell[17219, 846, 159, 6, 16, "Index",
      CellTags->"IrreducibleFA"]},
  "IsomorphicQDFA"->{
    Cell[17381, 854, 162, 6, 16, "Index",
      CellTags->"IsomorphicQDFA"]},
  "IthSymbolFA"->{
    Cell[17546, 862, 153, 6, 16, "Index",
      CellTags->"IthSymbolFA"]},
  "JoinSA"->{
    Cell[17702, 870, 138, 6, 16, "Index",
      CellTags->"JoinSA"]},
  "LanguageFA"->{
    Cell[17843, 878, 150, 6, 16, "Index",
      CellTags->"LanguageFA"]},
  "LanguageSort"->{
    Cell[17996, 886, 156, 6, 16, "Index",
      CellTags->"LanguageSort"]},
  "LanguageToSeries"->{
    Cell[18155, 894, 168, 6, 16, "Index",
      CellTags->"LanguageToSeries"]},
  "LeftQuotient"->{
    Cell[18326, 902, 156, 6, 16, "Index",
      CellTags->"LeftQuotient"]},
  "LengthDFA"->{
    Cell[18485, 910, 147, 6, 16, "Index",
      CellTags->"LengthDFA"]},
  "LocalQSA"->{
    Cell[18635, 918, 144, 6, 16, "Index",
      CellTags->"LocalQSA"]},
  "LocalUniversalFA"->{
    Cell[18782, 926, 168, 6, 16, "Index",
      CellTags->"LocalUniversalFA"]},
  "LoopAutomatonFA"->{
    Cell[18953, 934, 165, 6, 16, "Index",
      CellTags->"LoopAutomatonFA"]},
  "MakeHomomorphismDFA"->{
    Cell[19121, 942, 177, 6, 16, "Index",
      CellTags->"MakeHomomorphismDFA"]},
  "MakeHomomorphism"->{
    Cell[19301, 950, 168, 6, 16, "Index",
      CellTags->"MakeHomomorphism"]},
  "MatrixToTransitions"->{
    Cell[19472, 958, 177, 6, 16, "Index",
      CellTags->"MatrixToTransitions"]},
  "MinimalFischerFA"->{
    Cell[19652, 966, 168, 6, 16, "Index",
      CellTags->"MinimalFischerFA"]},
  "MinimizeDFA"->{
    Cell[19823, 974, 153, 6, 16, "Index",
      CellTags->"MinimizeDFA"]},
  "MinimizeFA"->{
    Cell[19979, 982, 150, 6, 16, "Index",
      CellTags->"MinimizeFA"]},
  "NFA"->{
    Cell[20132, 990, 129, 6, 16, "Index",
      CellTags->"NFA"]},
  "NNFAToFA"->{
    Cell[20264, 998, 144, 6, 16, "Index",
      CellTags->"NNFAToFA"]},
  "NNFA"->{
    Cell[20411, 1006, 132, 6, 16, "Index",
      CellTags->"NNFA"]},
  "NormalizeControl"->{
    Cell[20546, 1014, 168, 6, 16, "Index",
      CellTags->"NormalizeControl"]},
  "NormalizeFA"->{
    Cell[20717, 1022, 153, 6, 16, "Index",
      CellTags->"NormalizeFA"]},
  "NumberOfDFA"->{
    Cell[20873, 1030, 153, 6, 16, "Index",
      CellTags->"NumberOfDFA"]},
  "NumTransitions"->{
    Cell[21029, 1038, 162, 6, 16, "Index",
      CellTags->"NumTransitions"]},
  "PermutationSA"->{
    Cell[21194, 1046, 159, 6, 16, "Index",
      CellTags->"PermutationSA"]},
  "PermuteFA"->{
    Cell[21356, 1054, 147, 6, 16, "Index",
      CellTags->"PermuteFA"]},
  "PrintFA"->{
    Cell[21506, 1062, 141, 6, 16, "Index",
      CellTags->"PrintFA"]},
  "ProductFA"->{
    Cell[21650, 1070, 147, 6, 16, "Index",
      CellTags->"ProductFA"]},
  "ProductTransitions"->{
    Cell[21800, 1078, 174, 6, 16, "Index",
      CellTags->"ProductTransitions"]},
  "QuotientDFA"->{
    Cell[21977, 1086, 153, 6, 16, "Index",
      CellTags->"QuotientDFA"]},
  "QuotientMachineFA"->{
    Cell[22133, 1094, 171, 6, 16, "Index",
      CellTags->"QuotientMachineFA"]},
  "RandomDFA"->{
    Cell[22307, 1102, 147, 6, 16, "Index",
      CellTags->"RandomDFA"]},
  "RankOfDFA"->{
    Cell[22457, 1110, 147, 6, 16, "Index",
      CellTags->"RankOfDFA"]},
  "RankToDFA"->{
    Cell[22607, 1118, 147, 6, 16, "Index",
      CellTags->"RankToDFA"]},
  "DeleteTransitionFA"->{
    Cell[22757, 1126, 174, 6, 16, "Index",
      CellTags->"DeleteTransitionFA"]},
  "ReverseFA"->{
    Cell[22934, 1134, 147, 6, 16, "Index",
      CellTags->"ReverseFA"]},
  "SA"->{
    Cell[23084, 1142, 126, 6, 16, "Index",
      CellTags->"SA"]},
  "SelectFA"->{
    Cell[23213, 1150, 144, 6, 16, "Index",
      CellTags->"SelectFA"]},
  "SetAlphabet"->{
    Cell[23360, 1158, 153, 6, 16, "Index",
      CellTags->"SetAlphabet"]},
  "SetFinalFA"->{
    Cell[23516, 1166, 150, 6, 16, "Index",
      CellTags->"SetFinalFA"]},
  "SetInitialFA"->{
    Cell[23669, 1174, 156, 6, 16, "Index",
      CellTags->"SetInitialFA"]},
  "SetInitialFinalFA"->{
    Cell[23828, 1182, 171, 6, 16, "Index",
      CellTags->"SetInitialFinalFA"]},
  "SetStates"->{
    Cell[24002, 1190, 147, 6, 16, "Index",
      CellTags->"SetStates"]},
  "ShuffleProductFA"->{
    Cell[24152, 1198, 168, 6, 16, "Index",
      CellTags->"ShuffleProductFA"]},
  "SinkQDFA"->{
    Cell[24323, 1206, 144, 6, 16, "Index",
      CellTags->"SinkQDFA"]},
  "Size"->{
    Cell[24470, 1214, 132, 6, 16, "Index",
      CellTags->"Size"]},
  "SquareSA"->{
    Cell[24605, 1222, 144, 6, 16, "Index",
      CellTags->"SquareSA"]},
  "StarFA"->{
    Cell[24752, 1230, 138, 6, 16, "Index",
      CellTags->"StarFA"]},
  "StateMergeDFA"->{
    Cell[24893, 1238, 159, 6, 16, "Index",
      CellTags->"StateMergeDFA"]},
  "States"->{
    Cell[25055, 1246, 138, 6, 16, "Index",
      CellTags->"States"]},
  "SubsetQFA"->{
    Cell[25196, 1254, 147, 6, 16, "Index",
      CellTags->"SubsetQFA"]},
  "SubwordCounterDFA"->{
    Cell[25346, 1262, 171, 6, 16, "Index",
      CellTags->"SubwordCounterDFA"]},
  "SubwordDFA"->{
    Cell[25520, 1270, 150, 6, 16, "Index",
      CellTags->"SubwordDFA"]},
  "SumFA"->{
    Cell[25673, 1278, 135, 6, 16, "Index",
      CellTags->"SumFA"]},
  "SwitchTransitionFA"->{
    Cell[25811, 1286, 174, 6, 16, "Index",
      CellTags->"SwitchTransitionFA"]},
  "TheInitial"->{
    Cell[25988, 1294, 150, 6, 16, "Index",
      CellTags->"TheInitial"]},
  "ToCharacters"->{
    Cell[26141, 1302, 156, 6, 16, "Index",
      CellTags->"ToCharacters"]},
  "ToDFA"->{
    Cell[26300, 1310, 135, 6, 16, "Index",
      CellTags->"ToDFA"]},
  "ToEquationsDFA"->{
    Cell[26438, 1318, 162, 6, 16, "Index",
      CellTags->"ToEquationsDFA"]},
  "ToFA"->{
    Cell[26603, 1326, 132, 6, 16, "Index",
      CellTags->"ToFA"]},
  "ToFactorFA"->{
    Cell[26738, 1334, 150, 6, 16, "Index",
      CellTags->"ToFactorFA"]},
  "ToFrontierDFA"->{
    Cell[26891, 1342, 159, 6, 16, "Index",
      CellTags->"ToFrontierDFA"]},
  "ToGeneratorsFA"->{
    Cell[27053, 1350, 162, 6, 16, "Index",
      CellTags->"ToGeneratorsFA"]},
  "ToGraphFA"->{
    Cell[27218, 1358, 147, 6, 16, "Index",
      CellTags->"ToGraphFA"]},
  "ToKernelFA"->{
    Cell[27368, 1366, 150, 6, 16, "Index",
      CellTags->"ToKernelFA"]},
  "ToNFA"->{
    Cell[27521, 1374, 135, 6, 16, "Index",
      CellTags->"ToNFA"]},
  "ToRegularExpressionFA"->{
    Cell[27659, 1382, 183, 6, 16, "Index",
      CellTags->"ToRegularExpressionFA"]},
  "ToSA"->{
    Cell[27845, 1390, 132, 6, 16, "Index",
      CellTags->"ToSA"]},
  "ToSeries"->{
    Cell[27980, 1398, 144, 6, 16, "Index",
      CellTags->"ToSeries"]},
  "ToTransitions"->{
    Cell[28127, 1406, 159, 6, 16, "Index",
      CellTags->"ToTransitions"]},
  "TransferSequenceFA"->{
    Cell[28289, 1414, 174, 6, 16, "Index",
      CellTags->"TransferSequenceFA"]},
  "TransitionFunctionFA"->{
    Cell[28466, 1422, 180, 6, 16, "Index",
      CellTags->"TransitionFunctionFA"]},
  "TransitionMatrixFA"->{
    Cell[28649, 1430, 174, 6, 16, "Index",
      CellTags->"TransitionMatrixFA"]},
  "TransitionsToMatrix"->{
    Cell[28826, 1438, 177, 6, 16, "Index",
      CellTags->"TransitionsToMatrix"]},
  "Transitions"->{
    Cell[29006, 1446, 153, 6, 16, "Index",
      CellTags->"Transitions"]},
  "TransitiveLanguageQFA"->{
    Cell[29162, 1454, 183, 6, 16, "Index",
      CellTags->"TransitiveLanguageQFA"]},
  "TransitiveQFA"->{
    Cell[29348, 1462, 159, 6, 16, "Index",
      CellTags->"TransitiveQFA"]},
  "TrapStatesFA"->{
    Cell[29510, 1470, 156, 6, 16, "Index",
      CellTags->"TrapStatesFA"]},
  "TrimFA"->{
    Cell[29669, 1478, 138, 6, 16, "Index",
      CellTags->"TrimFA"]},
  "TropicalIdentityMatrix"->{
    Cell[29810, 1486, 186, 6, 16, "Index",
      CellTags->"TropicalIdentityMatrix"]},
  "TS"->{
    Cell[29999, 1494, 126, 6, 16, "Index",
      CellTags->"TS"]},
  "UnionFA"->{
    Cell[30128, 1502, 141, 6, 16, "Index",
      CellTags->"UnionFA"]},
  "VerifyFA"->{
    Cell[30272, 1510, 144, 6, 16, "Index",
      CellTags->"VerifyFA"]},
  "WordToFA"->{
    Cell[30419, 1518, 144, 6, 16, "Index",
      CellTags->"WordToFA"]},
  "ArdenSolve"->{
    Cell[30566, 1526, 150, 6, 16, "Index",
      CellTags->"ArdenSolve"]},
  "FormatX"->{
    Cell[30719, 1534, 141, 6, 16, "Index",
      CellTags->"FormatX"]},
  "REEpsQ"->{
    Cell[30863, 1542, 138, 6, 16, "Index",
      CellTags->"REEpsQ"]},
  "RegularExpressionToBEFA"->{
    Cell[31004, 1550, 189, 6, 16, "Index",
      CellTags->"RegularExpressionToBEFA"]},
  "RegularExpressionToFA"->{
    Cell[31196, 1558, 183, 6, 16, "Index",
      CellTags->"RegularExpressionToFA"]},
  "RegularExpressionToNNFA"->{
    Cell[31382, 1566, 189, 6, 16, "Index",
      CellTags->"RegularExpressionToNNFA"]},
  "REP"->{
    Cell[31574, 1574, 129, 6, 16, "Index",
      CellTags->"REP"]},
  "REQuotient"->{
    Cell[31706, 1582, 150, 6, 16, "Index",
      CellTags->"REQuotient"]},
  "RES"->{
    Cell[31859, 1590, 129, 6, 16, "Index",
      CellTags->"RES"]},
  "RESimplify"->{
    Cell[31991, 1598, 150, 6, 16, "Index",
      CellTags->"RESimplify"]},
  "RET"->{
    Cell[32144, 1606, 129, 6, 16, "Index",
      CellTags->"RET"]},
  "SubstituteRE"->{
    Cell[32276, 1614, 156, 6, 16, "Index",
      CellTags->"SubstituteRE"]},
  "ToRegExp"->{
    Cell[32435, 1622, 144, 6, 16, "Index",
      CellTags->"ToRegExp"]},
  "BFunctionToCA"->{
    Cell[32582, 1630, 159, 6, 16, "Index",
      CellTags->"BFunctionToCA"]},
  "CA"->{
    Cell[32744, 1638, 126, 6, 16, "Index",
      CellTags->"CA"]},
  "ClassifyCA"->{
    Cell[32873, 1646, 150, 6, 16, "Index",
      CellTags->"ClassifyCA"]},
  "ComposeCA"->{
    Cell[33026, 1654, 147, 6, 16, "Index",
      CellTags->"ComposeCA"]},
  "EvolutionCA"->{
    Cell[33176, 1662, 153, 6, 16, "Index",
      CellTags->"EvolutionCA"]},
  "DependencyCA"->{
    Cell[33332, 1670, 156, 6, 16, "Index",
      CellTags->"DependencyCA"]},
  "FSurjectiveCA"->{
    Cell[33491, 1678, 159, 6, 16, "Index",
      CellTags->"FSurjectiveCA"]},
  "FunctionToCA"->{
    Cell[33653, 1686, 156, 6, 16, "Index",
      CellTags->"FunctionToCA"]},
  "GlobalMapCA"->{
    Cell[33812, 1694, 153, 6, 16, "Index",
      CellTags->"GlobalMapCA"]},
  "InverseCA"->{
    Cell[33968, 1702, 147, 6, 16, "Index",
      CellTags->"InverseCA"]},
  "IterateCA"->{
    Cell[34118, 1710, 147, 6, 16, "Index",
      CellTags->"IterateCA"]},
  "LocalMapCA"->{
    Cell[34268, 1718, 150, 6, 16, "Index",
      CellTags->"LocalMapCA"]},
  "NumberOfCA"->{
    Cell[34421, 1726, 150, 6, 16, "Index",
      CellTags->"NumberOfCA"]},
  "NumberOfTotalisticCA"->{
    Cell[34574, 1734, 180, 6, 16, "Index",
      CellTags->"NumberOfTotalisticCA"]},
  "OrbitCA"->{
    Cell[34757, 1742, 141, 6, 16, "Index",
      CellTags->"OrbitCA"]},
  "PolynomialToCA"->{
    Cell[34901, 1750, 162, 6, 16, "Index",
      CellTags->"PolynomialToCA"]},
  "PrintCA"->{
    Cell[35066, 1758, 141, 6, 16, "Index",
      CellTags->"PrintCA"]},
  "RuleCA"->{
    Cell[35210, 1766, 138, 6, 16, "Index",
      CellTags->"RuleCA"]},
  "RulesToCA"->{
    Cell[35351, 1774, 147, 6, 16, "Index",
      CellTags->"RulesToCA"]},
  "SeedConfiguration"->{
    Cell[35501, 1782, 171, 6, 16, "Index",
      CellTags->"SeedConfiguration"]},
  "SimplifyCA"->{
    Cell[35675, 1790, 150, 6, 16, "Index",
      CellTags->"SimplifyCA"]},
  "ToRulesCA"->{
    Cell[35828, 1798, 147, 6, 16, "Index",
      CellTags->"ToRulesCA"]},
  "TotalisticRuleToCA"->{
    Cell[35978, 1806, 174, 6, 16, "Index",
      CellTags->"TotalisticRuleToCA"]},
  "ToTotalisticRuleCA"->{
    Cell[36155, 1814, 174, 6, 16, "Index",
      CellTags->"ToTotalisticRuleCA"]},
  "WelchCA"->{
    Cell[36332, 1822, 141, 6, 16, "Index",
      CellTags->"WelchCA"]},
  "WidthCA"->{
    Cell[36476, 1830, 141, 6, 16, "Index",
      CellTags->"WidthCA"]},
  "AddEdge"->{
    Cell[36620, 1838, 141, 6, 16, "Index",
      CellTags->"AddEdge"]},
  "AddVertex"->{
    Cell[36764, 1846, 147, 6, 16, "Index",
      CellTags->"AddVertex"]},
  "BiAccessibleGraph"->{
    Cell[36914, 1854, 171, 6, 16, "Index",
      CellTags->"BiAccessibleGraph"]},
  "AccessibleGraph"->{
    Cell[37088, 1862, 165, 6, 16, "Index",
      CellTags->"AccessibleGraph"]},
  "CirculantGraph"->{
    Cell[37256, 1870, 162, 6, 16, "Index",
      CellTags->"CirculantGraph"]},
  "CyclicQGraph"->{
    Cell[37421, 1878, 156, 6, 16, "Index",
      CellTags->"CyclicQGraph"]},
  "DeBruijnEdges"->{
    Cell[37580, 1886, 159, 6, 16, "Index",
      CellTags->"DeBruijnEdges"]},
  "DeBruijnGraph"->{
    Cell[37742, 1894, 159, 6, 16, "Index",
      CellTags->"DeBruijnGraph"]},
  "DegreeGraph"->{
    Cell[37904, 1902, 153, 6, 16, "Index",
      CellTags->"DegreeGraph"]},
  "DeleteEdge"->{
    Cell[38060, 1910, 150, 6, 16, "Index",
      CellTags->"DeleteEdge"]},
  "DeleteVertex"->{
    Cell[38213, 1918, 156, 6, 16, "Index",
      CellTags->"DeleteVertex"]},
  "EdgeQ"->{
    Cell[38372, 1926, 135, 6, 16, "Index",
      CellTags->"EdgeQ"]},
  "Edges"->{
    Cell[38510, 1934, 135, 6, 16, "Index",
      CellTags->"Edges"]},
  "Graph"->{
    Cell[38648, 1942, 135, 6, 16, "Index",
      CellTags->"Graph"]},
  "GridGraph"->{
    Cell[38786, 1950, 147, 6, 16, "Index",
      CellTags->"GridGraph"]},
  "LabelEdgeList"->{
    Cell[38936, 1958, 159, 6, 16, "Index",
      CellTags->"LabelEdgeList"]},
  "LongestPath"->{
    Cell[39098, 1966, 153, 6, 16, "Index",
      CellTags->"LongestPath"]},
  "NormalizeGraph"->{
    Cell[39254, 1974, 162, 6, 16, "Index",
      CellTags->"NormalizeGraph"]},
  "NonTransientGraph"->{
    Cell[39419, 1982, 171, 6, 16, "Index",
      CellTags->"NonTransientGraph"]},
  "NumEdges"->{
    Cell[39593, 1990, 144, 6, 16, "Index",
      CellTags->"NumEdges"]},
  "NumVertices"->{
    Cell[39740, 1998, 153, 6, 16, "Index",
      CellTags->"NumVertices"]},
  "PathGraph"->{
    Cell[39896, 2006, 147, 6, 16, "Index",
      CellTags->"PathGraph"]},
  "PermuteGraph"->{
    Cell[40046, 2014, 156, 6, 16, "Index",
      CellTags->"PermuteGraph"]},
  "ProductGraph"->{
    Cell[40205, 2022, 156, 6, 16, "Index",
      CellTags->"ProductGraph"]},
  "ProductLabeledGraph"->{
    Cell[40364, 2030, 177, 6, 16, "Index",
      CellTags->"ProductLabeledGraph"]},
  "ReverseGraph"->{
    Cell[40544, 2038, 156, 6, 16, "Index",
      CellTags->"ReverseGraph"]},
  "SetVertices"->{
    Cell[40703, 2046, 153, 6, 16, "Index",
      CellTags->"SetVertices"]},
  "ShortestPath"->{
    Cell[40859, 2054, 156, 6, 16, "Index",
      CellTags->"ShortestPath"]},
  "StronglyConnectedComponents"->{
    Cell[41018, 2062, 201, 6, 16, "Index",
      CellTags->"StronglyConnectedComponents"]},
  "SubGraph"->{
    Cell[41222, 2070, 144, 6, 16, "Index",
      CellTags->"SubGraph"]},
  "ToAdjacencyList"->{
    Cell[41369, 2078, 165, 6, 16, "Index",
      CellTags->"ToAdjacencyList"]},
  "ToAdjacencyMatrix"->{
    Cell[41537, 2086, 171, 6, 16, "Index",
      CellTags->"ToAdjacencyMatrix"]},
  "ToDirectedAcyclicGraph"->{
    Cell[41711, 2094, 186, 6, 16, "Index",
      CellTags->"ToDirectedAcyclicGraph"]},
  "ToEdgeList"->{
    Cell[41900, 2102, 150, 6, 16, "Index",
      CellTags->"ToEdgeList"]},
  "ToTDGraph"->{
    Cell[42053, 2110, 147, 6, 16, "Index",
      CellTags->"ToTDGraph"]},
  "TypeGraph"->{
    Cell[42203, 2118, 147, 6, 16, "Index",
      CellTags->"TypeGraph"]},
  "VertexSet"->{
    Cell[42353, 2126, 147, 6, 16, "Index",
      CellTags->"VertexSet"]},
  "WeaklyConnectedComponents"->{
    Cell[42503, 2134, 195, 6, 16, "Index",
      CellTags->"WeaklyConnectedComponents"]},
  "AllTimes"->{
    Cell[42701, 2142, 144, 6, 16, "Index",
      CellTags->"AllTimes"]},
  "AperiodicQSG"->{
    Cell[42848, 2150, 156, 6, 16, "Index",
      CellTags->"AperiodicQSG"]},
  "AperiodicSG"->{
    Cell[43007, 2158, 153, 6, 16, "Index",
      CellTags->"AperiodicSG"]},
  "BlocksToDClass"->{
    Cell[43163, 2166, 162, 6, 16, "Index",
      CellTags->"BlocksToDClass"]},
  "CollapseT"->{
    Cell[43328, 2174, 147, 6, 16, "Index",
      CellTags->"CollapseT"]},
  "ConstantT"->{
    Cell[43478, 2182, 147, 6, 16, "Index",
      CellTags->"ConstantT"]},
  "CycleDecompositionT"->{
    Cell[43628, 2190, 177, 6, 16, "Index",
      CellTags->"CycleDecompositionT"]},
  "CycleToT"->{
    Cell[43808, 2198, 144, 6, 16, "Index",
      CellTags->"CycleToT"]},
  "DC"->{
    Cell[43955, 2206, 126, 6, 16, "Index",
      CellTags->"DC"]},
  "DClassDecomposition"->{
    Cell[44084, 2214, 177, 6, 16, "Index",
      CellTags->"DClassDecomposition"]},
  "DClassSize"->{
    Cell[44264, 2222, 150, 6, 16, "Index",
      CellTags->"DClassSize"]},
  "DClassT"->{
    Cell[44417, 2230, 141, 6, 16, "Index",
      CellTags->"DClassT"]},
  "DClassToBlocks"->{
    Cell[44561, 2238, 162, 6, 16, "Index",
      CellTags->"DClassToBlocks"]},
  "DihedralGroupSG"->{
    Cell[44726, 2246, 165, 6, 16, "Index",
      CellTags->"DihedralGroupSG"]},
  "GEN"->{
    Cell[44894, 2254, 129, 6, 16, "Index",
      CellTags->"GEN"]},
  "GenerateCSM"->{
    Cell[45026, 2262, 153, 6, 16, "Index",
      CellTags->"GenerateCSM"]},
  "GenerateCayleyGraph"->{
    Cell[45182, 2270, 177, 6, 16, "Index",
      CellTags->"GenerateCayleyGraph"]},
  "GenerateSG"->{
    Cell[45362, 2278, 150, 6, 16, "Index",
      CellTags->"GenerateSG"]},
  "GreenHQT"->{
    Cell[45515, 2286, 144, 6, 16, "Index",
      CellTags->"GreenHQT"]},
  "GreenJQT"->{
    Cell[45662, 2294, 144, 6, 16, "Index",
      CellTags->"GreenJQT"]},
  "GreenLQT"->{
    Cell[45809, 2302, 144, 6, 16, "Index",
      CellTags->"GreenLQT"]},
  "GreenRQT"->{
    Cell[45956, 2310, 144, 6, 16, "Index",
      CellTags->"GreenRQT"]},
  "HClassSize"->{
    Cell[46103, 2318, 150, 6, 16, "Index",
      CellTags->"HClassSize"]},
  "HClassT"->{
    Cell[46256, 2326, 141, 6, 16, "Index",
      CellTags->"HClassT"]},
  "HTrivialQSG"->{
    Cell[46400, 2334, 153, 6, 16, "Index",
      CellTags->"HTrivialQSG"]},
  "IdealT"->{
    Cell[46556, 2342, 138, 6, 16, "Index",
      CellTags->"IdealT"]},
  "IdemSG"->{
    Cell[46697, 2350, 138, 6, 16, "Index",
      CellTags->"IdemSG"]},
  "ImageT"->{
    Cell[46838, 2358, 138, 6, 16, "Index",
      CellTags->"ImageT"]},
  "InGroupSG"->{
    Cell[46979, 2366, 147, 6, 16, "Index",
      CellTags->"InGroupSG"]},
  "InverseT"->{
    Cell[47129, 2374, 144, 6, 16, "Index",
      CellTags->"InverseT"]},
  "JTrivialQSG"->{
    Cell[47276, 2382, 153, 6, 16, "Index",
      CellTags->"JTrivialQSG"]},
  "JTrivialSG"->{
    Cell[47432, 2390, 150, 6, 16, "Index",
      CellTags->"JTrivialSG"]},
  "KernelImageToT"->{
    Cell[47585, 2398, 162, 6, 16, "Index",
      CellTags->"KernelImageToT"]},
  "KernelT"->{
    Cell[47750, 2406, 141, 6, 16, "Index",
      CellTags->"KernelT"]},
  "LeftIdealT"->{
    Cell[47894, 2414, 150, 6, 16, "Index",
      CellTags->"LeftIdealT"]},
  "LeftNullSG"->{
    Cell[48047, 2422, 150, 6, 16, "Index",
      CellTags->"LeftNullSG"]},
  "LeftOneSG"->{
    Cell[48200, 2430, 147, 6, 16, "Index",
      CellTags->"LeftOneSG"]},
  "LocallyCommutativeQSG"->{
    Cell[48350, 2438, 183, 6, 16, "Index",
      CellTags->"LocallyCommutativeQSG"]},
  "LocallyIdempotentQSG"->{
    Cell[48536, 2446, 180, 6, 16, "Index",
      CellTags->"LocallyIdempotentQSG"]},
  "Merge12T"->{
    Cell[48719, 2454, 144, 6, 16, "Index",
      CellTags->"Merge12T"]},
  "MakeMonoidSG"->{
    Cell[48866, 2462, 156, 6, 16, "Index",
      CellTags->"MakeMonoidSG"]},
  "MonoidQSG"->{
    Cell[49025, 2470, 147, 6, 16, "Index",
      CellTags->"MonoidQSG"]},
  "NilpotentQSG"->{
    Cell[49175, 2478, 156, 6, 16, "Index",
      CellTags->"NilpotentQSG"]},
  "NullSG"->{
    Cell[49334, 2486, 138, 6, 16, "Index",
      CellTags->"NullSG"]},
  "OneSG"->{
    Cell[49475, 2494, 135, 6, 16, "Index",
      CellTags->"OneSG"]},
  "OneT"->{
    Cell[49613, 2502, 132, 6, 16, "Index",
      CellTags->"OneT"]},
  "OrderT"->{
    Cell[49748, 2510, 138, 6, 16, "Index",
      CellTags->"OrderT"]},
  "PrintDClass"->{
    Cell[49889, 2518, 153, 6, 16, "Index",
      CellTags->"PrintDClass"]},
  "PrintEquations"->{
    Cell[50045, 2526, 162, 6, 16, "Index",
      CellTags->"PrintEquations"]},
  "PrintWitnesses"->{
    Cell[50210, 2534, 162, 6, 16, "Index",
      CellTags->"PrintWitnesses"]},
  "RegularSG"->{
    Cell[50375, 2542, 147, 6, 16, "Index",
      CellTags->"RegularSG"]},
  "RandomT"->{
    Cell[50525, 2550, 141, 6, 16, "Index",
      CellTags->"RandomT"]},
  "RankT"->{
    Cell[50669, 2558, 135, 6, 16, "Index",
      CellTags->"RankT"]},
  "RightIdealT"->{
    Cell[50807, 2566, 153, 6, 16, "Index",
      CellTags->"RightIdealT"]},
  "RightNullSG"->{
    Cell[50963, 2574, 153, 6, 16, "Index",
      CellTags->"RightNullSG"]},
  "RightOneSG"->{
    Cell[51119, 2582, 150, 6, 16, "Index",
      CellTags->"RightOneSG"]},
  "ShiftT"->{
    Cell[51272, 2590, 138, 6, 16, "Index",
      CellTags->"ShiftT"]},
  "SG"->{
    Cell[51413, 2598, 126, 6, 16, "Index",
      CellTags->"SG"]},
  "SolveSG"->{
    Cell[51542, 2606, 141, 6, 16, "Index",
      CellTags->"SolveSG"]},
  "SymmetricGroupSG"->{
    Cell[51686, 2614, 168, 6, 16, "Index",
      CellTags->"SymmetricGroupSG"]},
  "SyntacticCongruence"->{
    Cell[51857, 2622, 177, 6, 16, "Index",
      CellTags->"SyntacticCongruence"]},
  "SyntacticHomomorphism"->{
    Cell[52037, 2630, 183, 6, 16, "Index",
      CellTags->"SyntacticHomomorphism"]},
  "SyntacticSG"->{
    Cell[52223, 2638, 153, 6, 16, "Index",
      CellTags->"SyntacticSG"]},
  "T"->{
    Cell[52379, 2646, 123, 6, 16, "Index",
      CellTags->"T"]},
  "TableSG"->{
    Cell[52505, 2654, 141, 6, 16, "Index",
      CellTags->"TableSG"]},
  "ToIdentityString"->{
    Cell[52649, 2662, 168, 6, 16, "Index",
      CellTags->"ToIdentityString"]},
  "TransformationSG"->{
    Cell[52820, 2670, 168, 6, 16, "Index",
      CellTags->"TransformationSG"]},
  "TransientPeriodicT"->{
    Cell[52991, 2678, 174, 6, 16, "Index",
      CellTags->"TransientPeriodicT"]},
  "TranspositionT"->{
    Cell[53168, 2686, 162, 6, 16, "Index",
      CellTags->"TranspositionT"]},
  "UnitElement"->{
    Cell[53333, 2694, 153, 6, 16, "Index",
      CellTags->"UnitElement"]},
  "EquationsToWitnesses"->{
    Cell[53489, 2702, 180, 6, 16, "Index",
      CellTags->"EquationsToWitnesses"]},
  "FromIdentityString"->{
    Cell[53672, 2710, 174, 6, 16, "Index",
      CellTags->"FromIdentityString"]},
  "IrreducibleQ"->{
    Cell[53849, 2718, 156, 6, 16, "Index",
      CellTags->"IrreducibleQ"]},
  "PairsToRules"->{
    Cell[54008, 2726, 156, 6, 16, "Index",
      CellTags->"PairsToRules"]},
  "RulesToPairs"->{
    Cell[54167, 2734, 156, 6, 16, "Index",
      CellTags->"RulesToPairs"]},
  "SimplifyEquations"->{
    Cell[54326, 2742, 171, 6, 16, "Index",
      CellTags->"SimplifyEquations"]},
  "SimplifyRewriteSystem"->{
    Cell[54500, 2750, 183, 6, 16, "Index",
      CellTags->"SimplifyRewriteSystem"]},
  "WordReduce"->{
    Cell[54686, 2758, 150, 6, 16, "Index",
      CellTags->"WordReduce"]},
  "BooleanComplement"->{
    Cell[54839, 2766, 171, 6, 16, "Index",
      CellTags->"BooleanComplement"]},
  "BooleanComposition"->{
    Cell[55013, 2774, 174, 6, 16, "Index",
      CellTags->"BooleanComposition"]},
  "BooleanConverse"->{
    Cell[55190, 2782, 165, 6, 16, "Index",
      CellTags->"BooleanConverse"]},
  "BooleanIntersection"->{
    Cell[55358, 2790, 177, 6, 16, "Index",
      CellTags->"BooleanIntersection"]},
  "BooleanPower"->{
    Cell[55538, 2798, 156, 6, 16, "Index",
      CellTags->"BooleanPower"]},
  "BooleanUnion"->{
    Cell[55697, 2806, 156, 6, 16, "Index",
      CellTags->"BooleanUnion"]},
  "RelationToMatrix"->{
    Cell[55856, 2814, 168, 6, 16, "Index",
      CellTags->"RelationToMatrix"]},
  "ToClasses"->{
    Cell[56027, 2822, 147, 6, 16, "Index",
      CellTags->"ToClasses"]},
  "TransitiveClosure"->{
    Cell[56177, 2830, 171, 6, 16, "Index",
      CellTags->"TransitiveClosure"]},
  "Warshall"->{
    Cell[56351, 2838, 144, 6, 16, "Index",
      CellTags->"Warshall"]},
  "AnalyzeOrbit"->{
    Cell[56498, 2846, 156, 6, 16, "Index",
      CellTags->"AnalyzeOrbit"]},
  "CartesianProduct"->{
    Cell[56657, 2854, 168, 6, 16, "Index",
      CellTags->"CartesianProduct"]},
  "ClosureSearch"->{
    Cell[56828, 2862, 159, 6, 16, "Index",
      CellTags->"ClosureSearch"]},
  "Closure"->{
    Cell[56990, 2870, 141, 6, 16, "Index",
      CellTags->"Closure"]},
  "DeleteDuplicates"->{
    Cell[57134, 2878, 168, 6, 16, "Index",
      CellTags->"DeleteDuplicates"]},
  "DisjointQ"->{
    Cell[57305, 2886, 147, 6, 16, "Index",
      CellTags->"DisjointQ"]},
  "EnumForm"->{
    Cell[57455, 2894, 144, 6, 16, "Index",
      CellTags->"EnumForm"]},
  "FastPowerSet"->{
    Cell[57602, 2902, 156, 6, 16, "Index",
      CellTags->"FastPowerSet"]},
  "Frequencies"->{
    Cell[57761, 2910, 153, 6, 16, "Index",
      CellTags->"Frequencies"]},
  "FromBitVector"->{
    Cell[57917, 2918, 159, 6, 16, "Index",
      CellTags->"FromBitVector"]},
  "LongestCommonSubsequence"->{
    Cell[58079, 2926, 192, 6, 16, "Index",
      CellTags->"LongestCommonSubsequence"]},
  "MakeIndex"->{
    Cell[58274, 2934, 147, 6, 16, "Index",
      CellTags->"MakeIndex"]},
  "NonDecreasingSequences"->{
    Cell[58424, 2942, 186, 6, 16, "Index",
      CellTags->"NonDecreasingSequences"]},
  "Pairs"->{
    Cell[58613, 2950, 135, 6, 16, "Index",
      CellTags->"Pairs"]},
  "Partitions"->{
    Cell[58751, 2958, 150, 6, 16, "Index",
      CellTags->"Partitions"]},
  "PowerSet"->{
    Cell[58904, 2966, 144, 6, 16, "Index",
      CellTags->"PowerSet"]},
  "RandomPermutation"->{
    Cell[59051, 2974, 171, 6, 16, "Index",
      CellTags->"RandomPermutation"]},
  "RankingRules"->{
    Cell[59225, 2982, 156, 6, 16, "Index",
      CellTags->"RankingRules"]},
  "RootList"->{
    Cell[59384, 2990, 144, 6, 16, "Index",
      CellTags->"RootList"]},
  "SelectorQ"->{
    Cell[59531, 2998, 147, 6, 16, "Index",
      CellTags->"SelectorQ"]},
  "Shuffle"->{
    Cell[59681, 3006, 141, 6, 16, "Index",
      CellTags->"Shuffle"]},
  "SubsetQ"->{
    Cell[59825, 3014, 141, 6, 16, "Index",
      CellTags->"SubsetQ"]},
  "ToBitVector"->{
    Cell[59969, 3022, 153, 6, 16, "Index",
      CellTags->"ToBitVector"]},
  "ToList"->{
    Cell[60125, 3030, 138, 6, 16, "Index",
      CellTags->"ToList"]},
  "ToPairs"->{
    Cell[60266, 3038, 141, 6, 16, "Index",
      CellTags->"ToPairs"]},
  "Tuples"->{
    Cell[60410, 3046, 138, 6, 16, "Index",
      CellTags->"Tuples"]},
  "AssignFunction"->{
    Cell[60551, 3054, 162, 6, 16, "Index",
      CellTags->"AssignFunction"]},
  "Curry"->{
    Cell[60716, 3062, 135, 6, 16, "Index",
      CellTags->"Curry"]},
  "Dependency"->{
    Cell[60854, 3070, 150, 6, 16, "Index",
      CellTags->"Dependency"]},
  "ExtAutomata"->{
    Cell[61007, 3078, 153, 6, 16, "Index",
      CellTags->"ExtAutomata"]},
  "FlattenOne"->{
    Cell[61163, 3086, 150, 6, 16, "Index",
      CellTags->"FlattenOne"]},
  "FormatAutomata"->{
    Cell[61316, 3094, 162, 6, 16, "Index",
      CellTags->"FormatAutomata"]},
  "PositionList"->{
    Cell[61481, 3102, 156, 6, 16, "Index",
      CellTags->"PositionList"]},
  "PositionOne"->{
    Cell[61640, 3110, 153, 6, 16, "Index",
      CellTags->"PositionOne"]},
  "ReplaceParts"->{
    Cell[61796, 3118, 156, 6, 16, "Index",
      CellTags->"ReplaceParts"]},
  "SelectOptions"->{
    Cell[61955, 3126, 159, 6, 16, "Index",
      CellTags->"SelectOptions"]},
  "Status"->{
    Cell[62117, 3134, 138, 6, 16, "Index",
      CellTags->"Status"]},
  "SymbolList"->{
    Cell[62258, 3142, 150, 6, 16, "Index",
      CellTags->"SymbolList"]},
  "PostLoad"->{
    Cell[62411, 3150, 144, 6, 16, "Index",
      CellTags->"PostLoad"]},
  "PreLoad"->{
    Cell[62558, 3158, 141, 6, 16, "Index",
      CellTags->"PreLoad"]},
  "ColorQ"->{
    Cell[62702, 3166, 138, 6, 16, "Index",
      CellTags->"ColorQ"]},
  "DoShow"->{
    Cell[62843, 3174, 138, 6, 16, "Index",
      CellTags->"DoShow"]},
  "GridLine"->{
    Cell[62984, 3182, 144, 6, 16, "Index",
      CellTags->"GridLine"]},
  "GridPoints"->{
    Cell[63131, 3190, 150, 6, 16, "Index",
      CellTags->"GridPoints"]},
  "HueRasterColors"->{
    Cell[63284, 3198, 165, 6, 16, "Index",
      CellTags->"HueRasterColors"]},
  "MakePlotRange"->{
    Cell[63452, 3206, 159, 6, 16, "Index",
      CellTags->"MakePlotRange"]},
  "PlotComputationFA"->{
    Cell[63614, 3214, 171, 6, 16, "Index",
      CellTags->"PlotComputationFA"]},
  "PlotFunction"->{
    Cell[63788, 3222, 156, 6, 16, "Index",
      CellTags->"PlotFunction"]},
  "PlotMatrix"->{
    Cell[63947, 3230, 150, 6, 16, "Index",
      CellTags->"PlotMatrix"]},
  "PlotRelation"->{
    Cell[64100, 3238, 156, 6, 16, "Index",
      CellTags->"PlotRelation"]},
  "PlotTDGraph"->{
    Cell[64259, 3246, 153, 6, 16, "Index",
      CellTags->"PlotTDGraph"]},
  "PlotT"->{
    Cell[64415, 3254, 135, 6, 16, "Index",
      CellTags->"PlotT"]},
  "ShowArray"->{
    Cell[64553, 3262, 147, 6, 16, "Index",
      CellTags->"ShowArray"]},
  "StaircasePlot"->{
    Cell[64703, 3270, 159, 6, 16, "Index",
      CellTags->"StaircasePlot"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"MasterIndexHeading", 65590, 3298},
  {"AlgebraicForm", 65697, 3301},
  {"Alphabet", 65788, 3304},
  {"AlphabetQ", 65875, 3307},
  {"AlphabetSize", 65966, 3310},
  {"Concatenate", 66059, 3313},
  {"Eps", 66143, 3316},
  {"FromEps", 66223, 3319},
  {"FromFrontier", 66313, 3322},
  {"FrontierQ", 66405, 3325},
  {"MakeAlphabet", 66497, 3328},
  {"MakeWord", 66588, 3331},
  {"ParikhVector", 66679, 3334},
  {"RandomWord", 66772, 3337},
  {"ToBlocks", 66861, 3340},
  {"ToEps", 66945, 3343},
  {"ToFrontier", 67031, 3346},
  {"ToIndex", 67119, 3349},
  {"ToWord", 67203, 3352},
  {"WordBinomial", 67292, 3355},
  {"WordConjugateQ", 67389, 3358},
  {"WordConjugates", 67488, 3361},
  {"WordFactorizations", 67591, 3364},
  {"WordFactorQ", 67691, 3367},
  {"WordFactors", 67784, 3370},
  {"WordFusion", 67876, 3373},
  {"WordLength", 67967, 3376},
  {"WordOrder", 68057, 3379},
  {"WordPeriod", 68147, 3382},
  {"WordPower", 68237, 3385},
  {"WordPrefixQ", 68328, 3388},
  {"WordPrefixes", 68422, 3391},
  {"WordPrimitiveCount", 68523, 3394},
  {"WordPrimitiveQ", 68626, 3397},
  {"WordQ", 68716, 3400},
  {"WordReverse", 68803, 3403},
  {"WordRoot", 68893, 3406},
  {"WordRotate", 68982, 3409},
  {"Words", 69068, 3412},
  {"WordShuffle", 69155, 3415},
  {"WordSort", 69245, 3418},
  {"WordSuffixQ", 69335, 3421},
  {"WordSuffixes", 69429, 3424},
  {"AcceptQFA", 69521, 3427},
  {"AccessibleFA", 69613, 3430},
  {"AddTransitionFA", 69711, 3433},
  {"AllDFA", 69803, 3436},
  {"AmbiguousQFA", 69892, 3439},
  {"BEFA", 69979, 3442},
  {"BEFAToFA", 70062, 3445},
  {"BehaviorFA", 70151, 3448},
  {"BuildBEFA", 70241, 3451},
  {"BuildDFA", 70329, 3454},
  {"BuildNNFA", 70417, 3457},
  {"BuildStarDFA", 70509, 3460},
  {"CirculantSA", 70603, 3463},
  {"CoAccessibleFA", 70700, 3466},
  {"ComplementFA", 70798, 3469},
  {"CompleteFA", 70892, 3472},
  {"CompleteQFA", 70985, 3475},
  {"ComputationFA", 71081, 3478},
  {"ComputationGraphFA", 71184, 3481},
  {"ConcatenateFA", 71287, 3484},
  {"ConvertToFA", 71383, 3487},
  {"CounterDFA", 71476, 3490},
  {"CoverQDFA", 71567, 3493},
  {"DefiniteQFA", 71659, 3496},
  {"DegreesFA", 71751, 3499},
  {"DeleteStateFA", 71845, 3502},
  {"DeterministicQFA", 71946, 3505},
  {"DFA", 72037, 3508},
  {"DivisibilityDFA", 72127, 3511},
  {"EmptyDFA", 72222, 3514},
  {"EmptyQFA", 72310, 3517},
  {"EpsilonFreeQ", 72402, 3520},
  {"EpsilonEliminationFA", 72506, 3523},
  {"EquivalentQFA", 72611, 3526},
  {"FactorialQFA", 72708, 3529},
  {"FA", 72794, 3532},
  {"FinalVectorFA", 72881, 3535},
  {"Final", 72971, 3538},
  {"FiniteComplementSA", 73066, 3541},
  {"FrontierToDFA", 73169, 3544},
  {"FSMQ", 73258, 3547},
  {"FullQFA", 73341, 3550},
  {"FullTransitionMatrixFA", 73442, 3553},
  {"FullTransitions", 73551, 3556},
  {"FunctionToDFA", 73651, 3559},
  {"FunctionToSA", 73748, 3562},
  {"GenerateDFA", 73843, 3565},
  {"GenerateQuotients", 73943, 3568},
  {"GrowthSeriesDFA", 74047, 3571},
  {"HomomorphismFA", 74148, 3574},
  {"HurwitzProduct", 74248, 3577},
  {"IdealBaseFA", 74345, 3580},
  {"IdealQFA", 74436, 3583},
  {"InfiniteQFA", 74527, 3586},
  {"InitialVectorFA", 74625, 3589},
  {"Initial", 74719, 3592},
  {"IntersectionFA", 74812, 3595},
  {"IrreducibleFA", 74911, 3598},
  {"IsomorphicQDFA", 75010, 3601},
  {"IthSymbolFA", 75107, 3604},
  {"JoinSA", 75196, 3607},
  {"LanguageFA", 75284, 3610},
  {"LanguageSort", 75378, 3613},
  {"LanguageToSeries", 75478, 3616},
  {"LeftQuotient", 75578, 3619},
  {"LengthDFA", 75671, 3622},
  {"LocalQSA", 75760, 3625},
  {"LocalUniversalFA", 75856, 3628},
  {"LoopAutomatonFA", 75959, 3631},
  {"MakeHomomorphismDFA", 76065, 3634},
  {"MakeHomomorphism", 76172, 3637},
  {"MatrixToTransitions", 76279, 3640},
  {"MinimalFischerFA", 76386, 3643},
  {"MinimizeDFA", 76485, 3646},
  {"MinimizeFA", 76578, 3649},
  {"NFA", 76663, 3652},
  {"NNFAToFA", 76746, 3655},
  {"NNFA", 76830, 3658},
  {"NormalizeControl", 76923, 3661},
  {"NormalizeFA", 77023, 3664},
  {"NumberOfDFA", 77118, 3667},
  {"NumTransitions", 77216, 3670},
  {"PermutationSA", 77316, 3673},
  {"PermuteFA", 77411, 3676},
  {"PrintFA", 77500, 3679},
  {"ProductFA", 77589, 3682},
  {"ProductTransitions", 77689, 3685},
  {"QuotientDFA", 77791, 3688},
  {"QuotientMachineFA", 77892, 3691},
  {"RandomDFA", 77991, 3694},
  {"RankOfDFA", 78082, 3697},
  {"RankToDFA", 78173, 3700},
  {"DeleteTransitionFA", 78273, 3703},
  {"ReverseFA", 78373, 3706},
  {"SA", 78457, 3709},
  {"SelectFA", 78540, 3712},
  {"SetAlphabet", 78632, 3715},
  {"SetFinalFA", 78726, 3718},
  {"SetInitialFA", 78821, 3721},
  {"SetInitialFinalFA", 78923, 3724},
  {"SetStates", 79022, 3727},
  {"ShuffleProductFA", 79120, 3730},
  {"SinkQDFA", 79217, 3733},
  {"Size", 79302, 3736},
  {"SquareSA", 79387, 3739},
  {"StarFA", 79474, 3742},
  {"StateMergeDFA", 79566, 3745},
  {"States", 79658, 3748},
  {"SubsetQFA", 79746, 3751},
  {"SubwordCounterDFA", 79845, 3754},
  {"SubwordDFA", 79945, 3757},
  {"SumFA", 80033, 3760},
  {"SwitchTransitionFA", 80129, 3763},
  {"TheInitial", 80230, 3766},
  {"ToCharacters", 80325, 3769},
  {"ToDFA", 80415, 3772},
  {"ToEquationsDFA", 80507, 3775},
  {"ToFA", 80598, 3778},
  {"ToFactorFA", 80685, 3781},
  {"ToFrontierDFA", 80781, 3784},
  {"ToGeneratorsFA", 80881, 3787},
  {"ToGraphFA", 80977, 3790},
  {"ToKernelFA", 81069, 3793},
  {"ToNFA", 81157, 3796},
  {"ToRegularExpressionFA", 81256, 3799},
  {"ToSA", 81354, 3802},
  {"ToSeries", 81439, 3805},
  {"ToTransitions", 81533, 3808},
  {"TransferSequenceFA", 81637, 3811},
  {"TransitionFunctionFA", 81748, 3814},
  {"TransitionMatrixFA", 81859, 3817},
  {"TransitionsToMatrix", 81969, 3820},
  {"Transitions", 82072, 3823},
  {"TransitiveLanguageQFA", 82177, 3826},
  {"TransitiveQFA", 82284, 3829},
  {"TrapStatesFA", 82382, 3832},
  {"TrimFA", 82473, 3835},
  {"TropicalIdentityMatrix", 82574, 3838},
  {"TS", 82671, 3841},
  {"UnionFA", 82753, 3844},
  {"VerifyFA", 82841, 3847},
  {"WordToFA", 82930, 3850},
  {"ArdenSolve", 83021, 3853},
  {"FormatX", 83111, 3856},
  {"REEpsQ", 83197, 3859},
  {"RegularExpressionToBEFA", 83299, 3862},
  {"RegularExpressionToFA", 83416, 3865},
  {"RegularExpressionToNNFA", 83533, 3868},
  {"REP", 83632, 3871},
  {"REQuotient", 83718, 3874},
  {"RES", 83804, 3877},
  {"RESimplify", 83890, 3880},
  {"RET", 83976, 3883},
  {"SubstituteRE", 84064, 3886},
  {"ToRegExp", 84157, 3889},
  {"BFunctionToCA", 84251, 3892},
  {"CA", 84339, 3895},
  {"ClassifyCA", 84424, 3898},
  {"ComposeCA", 84516, 3901},
  {"EvolutionCA", 84609, 3904},
  {"DependencyCA", 84705, 3907},
  {"FSurjectiveCA", 84803, 3910},
  {"FunctionToCA", 84901, 3913},
  {"GlobalMapCA", 84997, 3916},
  {"InverseCA", 85090, 3919},
  {"IterateCA", 85181, 3922},
  {"LocalMapCA", 85273, 3925},
  {"NumberOfCA", 85366, 3928},
  {"NumberOfTotalisticCA", 85469, 3931},
  {"OrbitCA", 85569, 3934},
  {"PolynomialToCA", 85663, 3937},
  {"PrintCA", 85757, 3940},
  {"RuleCA", 85843, 3943},
  {"RulesToCA", 85931, 3946},
  {"SeedConfiguration", 86030, 3949},
  {"SimplifyCA", 86130, 3952},
  {"ToRulesCA", 86222, 3955},
  {"TotalisticRuleToCA", 86322, 3958},
  {"ToTotalisticRuleCA", 86431, 3961},
  {"WelchCA", 86529, 3964},
  {"WidthCA", 86616, 3967},
  {"AddEdge", 86703, 3970},
  {"AddVertex", 86792, 3973},
  {"BiAccessibleGraph", 86891, 3976},
  {"AccessibleGraph", 86996, 3979},
  {"CirculantGraph", 87098, 3982},
  {"CyclicQGraph", 87197, 3985},
  {"DeBruijnEdges", 87295, 3988},
  {"DeBruijnGraph", 87394, 3991},
  {"DegreeGraph", 87491, 3994},
  {"DeleteEdge", 87585, 3997},
  {"DeleteVertex", 87680, 4000},
  {"EdgeQ", 87770, 4003},
  {"Edges", 87853, 4006},
  {"Graph", 87936, 4009},
  {"GridGraph", 88023, 4012},
  {"LabelEdgeList", 88118, 4015},
  {"LongestPath", 88215, 4018},
  {"NormalizeGraph", 88313, 4021},
  {"NonTransientGraph", 88417, 4024},
  {"NumEdges", 88515, 4027},
  {"NumVertices", 88607, 4030},
  {"PathGraph", 88700, 4033},
  {"PermuteGraph", 88794, 4036},
  {"ProductGraph", 88891, 4039},
  {"ProductLabeledGraph", 88995, 4042},
  {"ReverseGraph", 89099, 4045},
  {"SetVertices", 89195, 4048},
  {"ShortestPath", 89291, 4051},
  {"StronglyConnectedComponents", 89403, 4054},
  {"SubGraph", 89511, 4057},
  {"ToAdjacencyList", 89607, 4060},
  {"ToAdjacencyMatrix", 89712, 4063},
  {"ToDirectedAcyclicGraph", 89824, 4066},
  {"ToEdgeList", 89929, 4069},
  {"ToTDGraph", 90021, 4072},
  {"TypeGraph", 90112, 4075},
  {"VertexSet", 90203, 4078},
  {"WeaklyConnectedComponents", 90310, 4081},
  {"AllTimes", 90416, 4084},
  {"AperiodicQSG", 90509, 4087},
  {"AperiodicSG", 90605, 4090},
  {"BlocksToDClass", 90703, 4093},
  {"CollapseT", 90799, 4096},
  {"ConstantT", 90890, 4099},
  {"CycleDecompositionT", 90991, 4102},
  {"CycleToT", 91091, 4105},
  {"DC", 91174, 4108},
  {"DClassDecomposition", 91268, 4111},
  {"DClassSize", 91370, 4114},
  {"DClassT", 91460, 4117},
  {"DClassToBlocks", 91554, 4120},
  {"DihedralGroupSG", 91656, 4123},
  {"GEN", 91747, 4126},
  {"GenerateCSM", 91834, 4129},
  {"GenerateCayleyGraph", 91937, 4132},
  {"GenerateSG", 92039, 4135},
  {"GreenHQT", 92130, 4138},
  {"GreenJQT", 92219, 4141},
  {"GreenLQT", 92308, 4144},
  {"GreenRQT", 92397, 4147},
  {"HClassSize", 92488, 4150},
  {"HClassT", 92578, 4153},
  {"HTrivialQSG", 92669, 4156},
  {"IdealT", 92759, 4159},
  {"IdemSG", 92844, 4162},
  {"ImageT", 92929, 4165},
  {"InGroupSG", 93017, 4168},
  {"InverseT", 93107, 4171},
  {"JTrivialQSG", 93199, 4174},
  {"JTrivialSG", 93293, 4177},
  {"KernelImageToT", 93390, 4180},
  {"KernelT", 93484, 4183},
  {"LeftIdealT", 93574, 4186},
  {"LeftNullSG", 93667, 4189},
  {"LeftOneSG", 93759, 4192},
  {"LocallyCommutativeQSG", 93862, 4195},
  {"LocallyIdempotentQSG", 93976, 4198},
  {"Merge12T", 94077, 4201},
  {"MakeMonoidSG", 94170, 4204},
  {"MonoidQSG", 94264, 4207},
  {"NilpotentQSG", 94358, 4210},
  {"NullSG", 94449, 4213},
  {"OneSG", 94533, 4216},
  {"OneT", 94615, 4219},
  {"OrderT", 94698, 4222},
  {"PrintDClass", 94788, 4225},
  {"PrintEquations", 94886, 4228},
  {"PrintWitnesses", 94987, 4231},
  {"RegularSG", 95083, 4234},
  {"RandomT", 95172, 4237},
  {"RankT", 95257, 4240},
  {"RightIdealT", 95346, 4243},
  {"RightNullSG", 95441, 4246},
  {"RightOneSG", 95535, 4249},
  {"ShiftT", 95624, 4252},
  {"SG", 95705, 4255},
  {"SolveSG", 95787, 4258},
  {"SymmetricGroupSG", 95883, 4261},
  {"SyntacticCongruence", 95991, 4264},
  {"SyntacticHomomorphism", 96104, 4267},
  {"SyntacticSG", 96209, 4270},
  {"T", 96294, 4273},
  {"TableSG", 96375, 4276},
  {"ToIdentityString", 96471, 4279},
  {"TransformationSG", 96576, 4282},
  {"TransientPeriodicT", 96683, 4285},
  {"TranspositionT", 96788, 4288},
  {"UnitElement", 96886, 4291},
  {"EquationsToWitnesses", 96990, 4294},
  {"FromIdentityString", 97101, 4297},
  {"IrreducibleQ", 97204, 4300},
  {"PairsToRules", 97301, 4303},
  {"RulesToPairs", 97398, 4306},
  {"SimplifyEquations", 97500, 4309},
  {"SimplifyRewriteSystem", 97611, 4312},
  {"WordReduce", 97715, 4315},
  {"BooleanComplement", 97815, 4318},
  {"BooleanComposition", 97923, 4321},
  {"BooleanConverse", 98029, 4324},
  {"BooleanIntersection", 98136, 4327},
  {"BooleanPower", 98240, 4330},
  {"BooleanUnion", 98337, 4333},
  {"RelationToMatrix", 98438, 4336},
  {"ToClasses", 98536, 4339},
  {"TransitiveClosure", 98635, 4342},
  {"Warshall", 98733, 4345},
  {"AnalyzeOrbit", 98826, 4348},
  {"CartesianProduct", 98927, 4351},
  {"ClosureSearch", 99029, 4354},
  {"Closure", 99122, 4357},
  {"DeleteDuplicates", 99218, 4360},
  {"DisjointQ", 99316, 4363},
  {"EnumForm", 99406, 4366},
  {"FastPowerSet", 99499, 4369},
  {"Frequencies", 99595, 4372},
  {"FromBitVector", 99692, 4375},
  {"LongestCommonSubsequence", 99802, 4378},
  {"MakeIndex", 99908, 4381},
  {"NonDecreasingSequences", 100012, 4384},
  {"Pairs", 100112, 4387},
  {"Partitions", 100200, 4390},
  {"PowerSet", 100291, 4393},
  {"RandomPermutation", 100389, 4396},
  {"RankingRules", 100491, 4399},
  {"RootList", 100584, 4402},
  {"SelectorQ", 100674, 4405},
  {"Shuffle", 100763, 4408},
  {"SubsetQ", 100850, 4411},
  {"ToBitVector", 100941, 4414},
  {"ToList", 101031, 4417},
  {"ToPairs", 101117, 4420},
  {"Tuples", 101203, 4423},
  {"AssignFunction", 101296, 4426},
  {"Curry", 101388, 4429},
  {"Dependency", 101476, 4432},
  {"ExtAutomata", 101570, 4435},
  {"FlattenOne", 101664, 4438},
  {"FormatAutomata", 101761, 4441},
  {"PositionList", 101860, 4444},
  {"PositionOne", 101956, 4447},
  {"ReplaceParts", 102052, 4450},
  {"SelectOptions", 102150, 4453},
  {"Status", 102242, 4456},
  {"SymbolList", 102331, 4459},
  {"PostLoad", 102422, 4462},
  {"PreLoad", 102510, 4465},
  {"ColorQ", 102596, 4468},
  {"DoShow", 102681, 4471},
  {"GridLine", 102768, 4474},
  {"GridPoints", 102859, 4477},
  {"HueRasterColors", 102957, 4480},
  {"MakePlotRange", 103058, 4483},
  {"PlotComputationFA", 103161, 4486},
  {"PlotFunction", 103263, 4489},
  {"PlotMatrix", 103358, 4492},
  {"PlotRelation", 103453, 4495},
  {"PlotTDGraph", 103549, 4498},
  {"PlotT", 103638, 4501},
  {"ShowArray", 103725, 4504},
  {"StaircasePlot", 103820, 4507}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 66, 1, 41, "IndexSection",
  CellTags->"MasterIndexHeading"],
Cell[1823, 54, 159, 6, 16, "Index",
  CellTags->"AlgebraicForm"],
Cell[1985, 62, 144, 6, 16, "Index",
  CellTags->"Alphabet"],
Cell[2132, 70, 147, 6, 16, "Index",
  CellTags->"AlphabetQ"],
Cell[2282, 78, 156, 6, 16, "Index",
  CellTags->"AlphabetSize"],
Cell[2441, 86, 153, 6, 16, "Index",
  CellTags->"Concatenate"],
Cell[2597, 94, 129, 6, 16, "Index",
  CellTags->"Eps"],
Cell[2729, 102, 141, 6, 16, "Index",
  CellTags->"FromEps"],
Cell[2873, 110, 156, 6, 16, "Index",
  CellTags->"FromFrontier"],
Cell[3032, 118, 147, 6, 16, "Index",
  CellTags->"FrontierQ"],
Cell[3182, 126, 156, 6, 16, "Index",
  CellTags->"MakeAlphabet"],
Cell[3341, 134, 144, 6, 16, "Index",
  CellTags->"MakeWord"],
Cell[3488, 142, 156, 6, 16, "Index",
  CellTags->"ParikhVector"],
Cell[3647, 150, 150, 6, 16, "Index",
  CellTags->"RandomWord"],
Cell[3800, 158, 144, 6, 16, "Index",
  CellTags->"ToBlocks"],
Cell[3947, 166, 135, 6, 16, "Index",
  CellTags->"ToEps"],
Cell[4085, 174, 150, 6, 16, "Index",
  CellTags->"ToFrontier"],
Cell[4238, 182, 141, 6, 16, "Index",
  CellTags->"ToIndex"],
Cell[4382, 190, 138, 6, 16, "Index",
  CellTags->"ToWord"],
Cell[4523, 198, 156, 6, 16, "Index",
  CellTags->"WordBinomial"],
Cell[4682, 206, 162, 6, 16, "Index",
  CellTags->"WordConjugateQ"],
Cell[4847, 214, 162, 6, 16, "Index",
  CellTags->"WordConjugates"],
Cell[5012, 222, 174, 6, 16, "Index",
  CellTags->"WordFactorizations"],
Cell[5189, 230, 153, 6, 16, "Index",
  CellTags->"WordFactorQ"],
Cell[5345, 238, 153, 6, 16, "Index",
  CellTags->"WordFactors"],
Cell[5501, 246, 150, 6, 16, "Index",
  CellTags->"WordFusion"],
Cell[5654, 254, 150, 6, 16, "Index",
  CellTags->"WordLength"],
Cell[5807, 262, 147, 6, 16, "Index",
  CellTags->"WordOrder"],
Cell[5957, 270, 150, 6, 16, "Index",
  CellTags->"WordPeriod"],
Cell[6110, 278, 147, 6, 16, "Index",
  CellTags->"WordPower"],
Cell[6260, 286, 153, 6, 16, "Index",
  CellTags->"WordPrefixQ"],
Cell[6416, 294, 156, 6, 16, "Index",
  CellTags->"WordPrefixes"],
Cell[6575, 302, 174, 6, 16, "Index",
  CellTags->"WordPrimitiveCount"],
Cell[6752, 310, 162, 6, 16, "Index",
  CellTags->"WordPrimitiveQ"],
Cell[6917, 318, 135, 6, 16, "Index",
  CellTags->"WordQ"],
Cell[7055, 326, 153, 6, 16, "Index",
  CellTags->"WordReverse"],
Cell[7211, 334, 144, 6, 16, "Index",
  CellTags->"WordRoot"],
Cell[7358, 342, 150, 6, 16, "Index",
  CellTags->"WordRotate"],
Cell[7511, 350, 135, 6, 16, "Index",
  CellTags->"Words"],
Cell[7649, 358, 153, 6, 16, "Index",
  CellTags->"WordShuffle"],
Cell[7805, 366, 144, 6, 16, "Index",
  CellTags->"WordSort"],
Cell[7952, 374, 153, 6, 16, "Index",
  CellTags->"WordSuffixQ"],
Cell[8108, 382, 156, 6, 16, "Index",
  CellTags->"WordSuffixes"],
Cell[8267, 390, 147, 6, 16, "Index",
  CellTags->"AcceptQFA"],
Cell[8417, 398, 156, 6, 16, "Index",
  CellTags->"AccessibleFA"],
Cell[8576, 406, 165, 6, 16, "Index",
  CellTags->"AddTransitionFA"],
Cell[8744, 414, 138, 6, 16, "Index",
  CellTags->"AllDFA"],
Cell[8885, 422, 156, 6, 16, "Index",
  CellTags->"AmbiguousQFA"],
Cell[9044, 430, 132, 6, 16, "Index",
  CellTags->"BEFA"],
Cell[9179, 438, 144, 6, 16, "Index",
  CellTags->"BEFAToFA"],
Cell[9326, 446, 150, 6, 16, "Index",
  CellTags->"BehaviorFA"],
Cell[9479, 454, 147, 6, 16, "Index",
  CellTags->"BuildBEFA"],
Cell[9629, 462, 144, 6, 16, "Index",
  CellTags->"BuildDFA"],
Cell[9776, 470, 147, 6, 16, "Index",
  CellTags->"BuildNNFA"],
Cell[9926, 478, 156, 6, 16, "Index",
  CellTags->"BuildStarDFA"],
Cell[10085, 486, 153, 6, 16, "Index",
  CellTags->"CirculantSA"],
Cell[10241, 494, 162, 6, 16, "Index",
  CellTags->"CoAccessibleFA"],
Cell[10406, 502, 156, 6, 16, "Index",
  CellTags->"ComplementFA"],
Cell[10565, 510, 150, 6, 16, "Index",
  CellTags->"CompleteFA"],
Cell[10718, 518, 153, 6, 16, "Index",
  CellTags->"CompleteQFA"],
Cell[10874, 526, 159, 6, 16, "Index",
  CellTags->"ComputationFA"],
Cell[11036, 534, 174, 6, 16, "Index",
  CellTags->"ComputationGraphFA"],
Cell[11213, 542, 159, 6, 16, "Index",
  CellTags->"ConcatenateFA"],
Cell[11375, 550, 153, 6, 16, "Index",
  CellTags->"ConvertToFA"],
Cell[11531, 558, 150, 6, 16, "Index",
  CellTags->"CounterDFA"],
Cell[11684, 566, 147, 6, 16, "Index",
  CellTags->"CoverQDFA"],
Cell[11834, 574, 153, 6, 16, "Index",
  CellTags->"DefiniteQFA"],
Cell[11990, 582, 147, 6, 16, "Index",
  CellTags->"DegreesFA"],
Cell[12140, 590, 159, 6, 16, "Index",
  CellTags->"DeleteStateFA"],
Cell[12302, 598, 168, 6, 16, "Index",
  CellTags->"DeterministicQFA"],
Cell[12473, 606, 129, 6, 16, "Index",
  CellTags->"DFA"],
Cell[12605, 614, 165, 6, 16, "Index",
  CellTags->"DivisibilityDFA"],
Cell[12773, 622, 144, 6, 16, "Index",
  CellTags->"EmptyDFA"],
Cell[12920, 630, 144, 6, 16, "Index",
  CellTags->"EmptyQFA"],
Cell[13067, 638, 156, 6, 16, "Index",
  CellTags->"EpsilonFreeQ"],
Cell[13226, 646, 180, 6, 16, "Index",
  CellTags->"EpsilonEliminationFA"],
Cell[13409, 654, 159, 6, 16, "Index",
  CellTags->"EquivalentQFA"],
Cell[13571, 662, 156, 6, 16, "Index",
  CellTags->"FactorialQFA"],
Cell[13730, 670, 126, 6, 16, "Index",
  CellTags->"FA"],
Cell[13859, 678, 159, 6, 16, "Index",
  CellTags->"FinalVectorFA"],
Cell[14021, 686, 135, 6, 16, "Index",
  CellTags->"Final"],
Cell[14159, 694, 174, 6, 16, "Index",
  CellTags->"FiniteComplementSA"],
Cell[14336, 702, 159, 6, 16, "Index",
  CellTags->"FrontierToDFA"],
Cell[14498, 710, 132, 6, 16, "Index",
  CellTags->"FSMQ"],
Cell[14633, 718, 141, 6, 16, "Index",
  CellTags->"FullQFA"],
Cell[14777, 726, 186, 6, 16, "Index",
  CellTags->"FullTransitionMatrixFA"],
Cell[14966, 734, 165, 6, 16, "Index",
  CellTags->"FullTransitions"],
Cell[15134, 742, 159, 6, 16, "Index",
  CellTags->"FunctionToDFA"],
Cell[15296, 750, 156, 6, 16, "Index",
  CellTags->"FunctionToSA"],
Cell[15455, 758, 153, 6, 16, "Index",
  CellTags->"GenerateDFA"],
Cell[15611, 766, 171, 6, 16, "Index",
  CellTags->"GenerateQuotients"],
Cell[15785, 774, 165, 6, 16, "Index",
  CellTags->"GrowthSeriesDFA"],
Cell[15953, 782, 162, 6, 16, "Index",
  CellTags->"HomomorphismFA"],
Cell[16118, 790, 162, 6, 16, "Index",
  CellTags->"HurwitzProduct"],
Cell[16283, 798, 153, 6, 16, "Index",
  CellTags->"IdealBaseFA"],
Cell[16439, 806, 144, 6, 16, "Index",
  CellTags->"IdealQFA"],
Cell[16586, 814, 153, 6, 16, "Index",
  CellTags->"InfiniteQFA"],
Cell[16742, 822, 165, 6, 16, "Index",
  CellTags->"InitialVectorFA"],
Cell[16910, 830, 141, 6, 16, "Index",
  CellTags->"Initial"],
Cell[17054, 838, 162, 6, 16, "Index",
  CellTags->"IntersectionFA"],
Cell[17219, 846, 159, 6, 16, "Index",
  CellTags->"IrreducibleFA"],
Cell[17381, 854, 162, 6, 16, "Index",
  CellTags->"IsomorphicQDFA"],
Cell[17546, 862, 153, 6, 16, "Index",
  CellTags->"IthSymbolFA"],
Cell[17702, 870, 138, 6, 16, "Index",
  CellTags->"JoinSA"],
Cell[17843, 878, 150, 6, 16, "Index",
  CellTags->"LanguageFA"],
Cell[17996, 886, 156, 6, 16, "Index",
  CellTags->"LanguageSort"],
Cell[18155, 894, 168, 6, 16, "Index",
  CellTags->"LanguageToSeries"],
Cell[18326, 902, 156, 6, 16, "Index",
  CellTags->"LeftQuotient"],
Cell[18485, 910, 147, 6, 16, "Index",
  CellTags->"LengthDFA"],
Cell[18635, 918, 144, 6, 16, "Index",
  CellTags->"LocalQSA"],
Cell[18782, 926, 168, 6, 16, "Index",
  CellTags->"LocalUniversalFA"],
Cell[18953, 934, 165, 6, 16, "Index",
  CellTags->"LoopAutomatonFA"],
Cell[19121, 942, 177, 6, 16, "Index",
  CellTags->"MakeHomomorphismDFA"],
Cell[19301, 950, 168, 6, 16, "Index",
  CellTags->"MakeHomomorphism"],
Cell[19472, 958, 177, 6, 16, "Index",
  CellTags->"MatrixToTransitions"],
Cell[19652, 966, 168, 6, 16, "Index",
  CellTags->"MinimalFischerFA"],
Cell[19823, 974, 153, 6, 16, "Index",
  CellTags->"MinimizeDFA"],
Cell[19979, 982, 150, 6, 16, "Index",
  CellTags->"MinimizeFA"],
Cell[20132, 990, 129, 6, 16, "Index",
  CellTags->"NFA"],
Cell[20264, 998, 144, 6, 16, "Index",
  CellTags->"NNFAToFA"],
Cell[20411, 1006, 132, 6, 16, "Index",
  CellTags->"NNFA"],
Cell[20546, 1014, 168, 6, 16, "Index",
  CellTags->"NormalizeControl"],
Cell[20717, 1022, 153, 6, 16, "Index",
  CellTags->"NormalizeFA"],
Cell[20873, 1030, 153, 6, 16, "Index",
  CellTags->"NumberOfDFA"],
Cell[21029, 1038, 162, 6, 16, "Index",
  CellTags->"NumTransitions"],
Cell[21194, 1046, 159, 6, 16, "Index",
  CellTags->"PermutationSA"],
Cell[21356, 1054, 147, 6, 16, "Index",
  CellTags->"PermuteFA"],
Cell[21506, 1062, 141, 6, 16, "Index",
  CellTags->"PrintFA"],
Cell[21650, 1070, 147, 6, 16, "Index",
  CellTags->"ProductFA"],
Cell[21800, 1078, 174, 6, 16, "Index",
  CellTags->"ProductTransitions"],
Cell[21977, 1086, 153, 6, 16, "Index",
  CellTags->"QuotientDFA"],
Cell[22133, 1094, 171, 6, 16, "Index",
  CellTags->"QuotientMachineFA"],
Cell[22307, 1102, 147, 6, 16, "Index",
  CellTags->"RandomDFA"],
Cell[22457, 1110, 147, 6, 16, "Index",
  CellTags->"RankOfDFA"],
Cell[22607, 1118, 147, 6, 16, "Index",
  CellTags->"RankToDFA"],
Cell[22757, 1126, 174, 6, 16, "Index",
  CellTags->"DeleteTransitionFA"],
Cell[22934, 1134, 147, 6, 16, "Index",
  CellTags->"ReverseFA"],
Cell[23084, 1142, 126, 6, 16, "Index",
  CellTags->"SA"],
Cell[23213, 1150, 144, 6, 16, "Index",
  CellTags->"SelectFA"],
Cell[23360, 1158, 153, 6, 16, "Index",
  CellTags->"SetAlphabet"],
Cell[23516, 1166, 150, 6, 16, "Index",
  CellTags->"SetFinalFA"],
Cell[23669, 1174, 156, 6, 16, "Index",
  CellTags->"SetInitialFA"],
Cell[23828, 1182, 171, 6, 16, "Index",
  CellTags->"SetInitialFinalFA"],
Cell[24002, 1190, 147, 6, 16, "Index",
  CellTags->"SetStates"],
Cell[24152, 1198, 168, 6, 16, "Index",
  CellTags->"ShuffleProductFA"],
Cell[24323, 1206, 144, 6, 16, "Index",
  CellTags->"SinkQDFA"],
Cell[24470, 1214, 132, 6, 16, "Index",
  CellTags->"Size"],
Cell[24605, 1222, 144, 6, 16, "Index",
  CellTags->"SquareSA"],
Cell[24752, 1230, 138, 6, 16, "Index",
  CellTags->"StarFA"],
Cell[24893, 1238, 159, 6, 16, "Index",
  CellTags->"StateMergeDFA"],
Cell[25055, 1246, 138, 6, 16, "Index",
  CellTags->"States"],
Cell[25196, 1254, 147, 6, 16, "Index",
  CellTags->"SubsetQFA"],
Cell[25346, 1262, 171, 6, 16, "Index",
  CellTags->"SubwordCounterDFA"],
Cell[25520, 1270, 150, 6, 16, "Index",
  CellTags->"SubwordDFA"],
Cell[25673, 1278, 135, 6, 16, "Index",
  CellTags->"SumFA"],
Cell[25811, 1286, 174, 6, 16, "Index",
  CellTags->"SwitchTransitionFA"],
Cell[25988, 1294, 150, 6, 16, "Index",
  CellTags->"TheInitial"],
Cell[26141, 1302, 156, 6, 16, "Index",
  CellTags->"ToCharacters"],
Cell[26300, 1310, 135, 6, 16, "Index",
  CellTags->"ToDFA"],
Cell[26438, 1318, 162, 6, 16, "Index",
  CellTags->"ToEquationsDFA"],
Cell[26603, 1326, 132, 6, 16, "Index",
  CellTags->"ToFA"],
Cell[26738, 1334, 150, 6, 16, "Index",
  CellTags->"ToFactorFA"],
Cell[26891, 1342, 159, 6, 16, "Index",
  CellTags->"ToFrontierDFA"],
Cell[27053, 1350, 162, 6, 16, "Index",
  CellTags->"ToGeneratorsFA"],
Cell[27218, 1358, 147, 6, 16, "Index",
  CellTags->"ToGraphFA"],
Cell[27368, 1366, 150, 6, 16, "Index",
  CellTags->"ToKernelFA"],
Cell[27521, 1374, 135, 6, 16, "Index",
  CellTags->"ToNFA"],
Cell[27659, 1382, 183, 6, 16, "Index",
  CellTags->"ToRegularExpressionFA"],
Cell[27845, 1390, 132, 6, 16, "Index",
  CellTags->"ToSA"],
Cell[27980, 1398, 144, 6, 16, "Index",
  CellTags->"ToSeries"],
Cell[28127, 1406, 159, 6, 16, "Index",
  CellTags->"ToTransitions"],
Cell[28289, 1414, 174, 6, 16, "Index",
  CellTags->"TransferSequenceFA"],
Cell[28466, 1422, 180, 6, 16, "Index",
  CellTags->"TransitionFunctionFA"],
Cell[28649, 1430, 174, 6, 16, "Index",
  CellTags->"TransitionMatrixFA"],
Cell[28826, 1438, 177, 6, 16, "Index",
  CellTags->"TransitionsToMatrix"],
Cell[29006, 1446, 153, 6, 16, "Index",
  CellTags->"Transitions"],
Cell[29162, 1454, 183, 6, 16, "Index",
  CellTags->"TransitiveLanguageQFA"],
Cell[29348, 1462, 159, 6, 16, "Index",
  CellTags->"TransitiveQFA"],
Cell[29510, 1470, 156, 6, 16, "Index",
  CellTags->"TrapStatesFA"],
Cell[29669, 1478, 138, 6, 16, "Index",
  CellTags->"TrimFA"],
Cell[29810, 1486, 186, 6, 16, "Index",
  CellTags->"TropicalIdentityMatrix"],
Cell[29999, 1494, 126, 6, 16, "Index",
  CellTags->"TS"],
Cell[30128, 1502, 141, 6, 16, "Index",
  CellTags->"UnionFA"],
Cell[30272, 1510, 144, 6, 16, "Index",
  CellTags->"VerifyFA"],
Cell[30419, 1518, 144, 6, 16, "Index",
  CellTags->"WordToFA"],
Cell[30566, 1526, 150, 6, 16, "Index",
  CellTags->"ArdenSolve"],
Cell[30719, 1534, 141, 6, 16, "Index",
  CellTags->"FormatX"],
Cell[30863, 1542, 138, 6, 16, "Index",
  CellTags->"REEpsQ"],
Cell[31004, 1550, 189, 6, 16, "Index",
  CellTags->"RegularExpressionToBEFA"],
Cell[31196, 1558, 183, 6, 16, "Index",
  CellTags->"RegularExpressionToFA"],
Cell[31382, 1566, 189, 6, 16, "Index",
  CellTags->"RegularExpressionToNNFA"],
Cell[31574, 1574, 129, 6, 16, "Index",
  CellTags->"REP"],
Cell[31706, 1582, 150, 6, 16, "Index",
  CellTags->"REQuotient"],
Cell[31859, 1590, 129, 6, 16, "Index",
  CellTags->"RES"],
Cell[31991, 1598, 150, 6, 16, "Index",
  CellTags->"RESimplify"],
Cell[32144, 1606, 129, 6, 16, "Index",
  CellTags->"RET"],
Cell[32276, 1614, 156, 6, 16, "Index",
  CellTags->"SubstituteRE"],
Cell[32435, 1622, 144, 6, 16, "Index",
  CellTags->"ToRegExp"],
Cell[32582, 1630, 159, 6, 16, "Index",
  CellTags->"BFunctionToCA"],
Cell[32744, 1638, 126, 6, 16, "Index",
  CellTags->"CA"],
Cell[32873, 1646, 150, 6, 16, "Index",
  CellTags->"ClassifyCA"],
Cell[33026, 1654, 147, 6, 16, "Index",
  CellTags->"ComposeCA"],
Cell[33176, 1662, 153, 6, 16, "Index",
  CellTags->"EvolutionCA"],
Cell[33332, 1670, 156, 6, 16, "Index",
  CellTags->"DependencyCA"],
Cell[33491, 1678, 159, 6, 16, "Index",
  CellTags->"FSurjectiveCA"],
Cell[33653, 1686, 156, 6, 16, "Index",
  CellTags->"FunctionToCA"],
Cell[33812, 1694, 153, 6, 16, "Index",
  CellTags->"GlobalMapCA"],
Cell[33968, 1702, 147, 6, 16, "Index",
  CellTags->"InverseCA"],
Cell[34118, 1710, 147, 6, 16, "Index",
  CellTags->"IterateCA"],
Cell[34268, 1718, 150, 6, 16, "Index",
  CellTags->"LocalMapCA"],
Cell[34421, 1726, 150, 6, 16, "Index",
  CellTags->"NumberOfCA"],
Cell[34574, 1734, 180, 6, 16, "Index",
  CellTags->"NumberOfTotalisticCA"],
Cell[34757, 1742, 141, 6, 16, "Index",
  CellTags->"OrbitCA"],
Cell[34901, 1750, 162, 6, 16, "Index",
  CellTags->"PolynomialToCA"],
Cell[35066, 1758, 141, 6, 16, "Index",
  CellTags->"PrintCA"],
Cell[35210, 1766, 138, 6, 16, "Index",
  CellTags->"RuleCA"],
Cell[35351, 1774, 147, 6, 16, "Index",
  CellTags->"RulesToCA"],
Cell[35501, 1782, 171, 6, 16, "Index",
  CellTags->"SeedConfiguration"],
Cell[35675, 1790, 150, 6, 16, "Index",
  CellTags->"SimplifyCA"],
Cell[35828, 1798, 147, 6, 16, "Index",
  CellTags->"ToRulesCA"],
Cell[35978, 1806, 174, 6, 16, "Index",
  CellTags->"TotalisticRuleToCA"],
Cell[36155, 1814, 174, 6, 16, "Index",
  CellTags->"ToTotalisticRuleCA"],
Cell[36332, 1822, 141, 6, 16, "Index",
  CellTags->"WelchCA"],
Cell[36476, 1830, 141, 6, 16, "Index",
  CellTags->"WidthCA"],
Cell[36620, 1838, 141, 6, 16, "Index",
  CellTags->"AddEdge"],
Cell[36764, 1846, 147, 6, 16, "Index",
  CellTags->"AddVertex"],
Cell[36914, 1854, 171, 6, 16, "Index",
  CellTags->"BiAccessibleGraph"],
Cell[37088, 1862, 165, 6, 16, "Index",
  CellTags->"AccessibleGraph"],
Cell[37256, 1870, 162, 6, 16, "Index",
  CellTags->"CirculantGraph"],
Cell[37421, 1878, 156, 6, 16, "Index",
  CellTags->"CyclicQGraph"],
Cell[37580, 1886, 159, 6, 16, "Index",
  CellTags->"DeBruijnEdges"],
Cell[37742, 1894, 159, 6, 16, "Index",
  CellTags->"DeBruijnGraph"],
Cell[37904, 1902, 153, 6, 16, "Index",
  CellTags->"DegreeGraph"],
Cell[38060, 1910, 150, 6, 16, "Index",
  CellTags->"DeleteEdge"],
Cell[38213, 1918, 156, 6, 16, "Index",
  CellTags->"DeleteVertex"],
Cell[38372, 1926, 135, 6, 16, "Index",
  CellTags->"EdgeQ"],
Cell[38510, 1934, 135, 6, 16, "Index",
  CellTags->"Edges"],
Cell[38648, 1942, 135, 6, 16, "Index",
  CellTags->"Graph"],
Cell[38786, 1950, 147, 6, 16, "Index",
  CellTags->"GridGraph"],
Cell[38936, 1958, 159, 6, 16, "Index",
  CellTags->"LabelEdgeList"],
Cell[39098, 1966, 153, 6, 16, "Index",
  CellTags->"LongestPath"],
Cell[39254, 1974, 162, 6, 16, "Index",
  CellTags->"NormalizeGraph"],
Cell[39419, 1982, 171, 6, 16, "Index",
  CellTags->"NonTransientGraph"],
Cell[39593, 1990, 144, 6, 16, "Index",
  CellTags->"NumEdges"],
Cell[39740, 1998, 153, 6, 16, "Index",
  CellTags->"NumVertices"],
Cell[39896, 2006, 147, 6, 16, "Index",
  CellTags->"PathGraph"],
Cell[40046, 2014, 156, 6, 16, "Index",
  CellTags->"PermuteGraph"],
Cell[40205, 2022, 156, 6, 16, "Index",
  CellTags->"ProductGraph"],
Cell[40364, 2030, 177, 6, 16, "Index",
  CellTags->"ProductLabeledGraph"],
Cell[40544, 2038, 156, 6, 16, "Index",
  CellTags->"ReverseGraph"],
Cell[40703, 2046, 153, 6, 16, "Index",
  CellTags->"SetVertices"],
Cell[40859, 2054, 156, 6, 16, "Index",
  CellTags->"ShortestPath"],
Cell[41018, 2062, 201, 6, 16, "Index",
  CellTags->"StronglyConnectedComponents"],
Cell[41222, 2070, 144, 6, 16, "Index",
  CellTags->"SubGraph"],
Cell[41369, 2078, 165, 6, 16, "Index",
  CellTags->"ToAdjacencyList"],
Cell[41537, 2086, 171, 6, 16, "Index",
  CellTags->"ToAdjacencyMatrix"],
Cell[41711, 2094, 186, 6, 16, "Index",
  CellTags->"ToDirectedAcyclicGraph"],
Cell[41900, 2102, 150, 6, 16, "Index",
  CellTags->"ToEdgeList"],
Cell[42053, 2110, 147, 6, 16, "Index",
  CellTags->"ToTDGraph"],
Cell[42203, 2118, 147, 6, 16, "Index",
  CellTags->"TypeGraph"],
Cell[42353, 2126, 147, 6, 16, "Index",
  CellTags->"VertexSet"],
Cell[42503, 2134, 195, 6, 16, "Index",
  CellTags->"WeaklyConnectedComponents"],
Cell[42701, 2142, 144, 6, 16, "Index",
  CellTags->"AllTimes"],
Cell[42848, 2150, 156, 6, 16, "Index",
  CellTags->"AperiodicQSG"],
Cell[43007, 2158, 153, 6, 16, "Index",
  CellTags->"AperiodicSG"],
Cell[43163, 2166, 162, 6, 16, "Index",
  CellTags->"BlocksToDClass"],
Cell[43328, 2174, 147, 6, 16, "Index",
  CellTags->"CollapseT"],
Cell[43478, 2182, 147, 6, 16, "Index",
  CellTags->"ConstantT"],
Cell[43628, 2190, 177, 6, 16, "Index",
  CellTags->"CycleDecompositionT"],
Cell[43808, 2198, 144, 6, 16, "Index",
  CellTags->"CycleToT"],
Cell[43955, 2206, 126, 6, 16, "Index",
  CellTags->"DC"],
Cell[44084, 2214, 177, 6, 16, "Index",
  CellTags->"DClassDecomposition"],
Cell[44264, 2222, 150, 6, 16, "Index",
  CellTags->"DClassSize"],
Cell[44417, 2230, 141, 6, 16, "Index",
  CellTags->"DClassT"],
Cell[44561, 2238, 162, 6, 16, "Index",
  CellTags->"DClassToBlocks"],
Cell[44726, 2246, 165, 6, 16, "Index",
  CellTags->"DihedralGroupSG"],
Cell[44894, 2254, 129, 6, 16, "Index",
  CellTags->"GEN"],
Cell[45026, 2262, 153, 6, 16, "Index",
  CellTags->"GenerateCSM"],
Cell[45182, 2270, 177, 6, 16, "Index",
  CellTags->"GenerateCayleyGraph"],
Cell[45362, 2278, 150, 6, 16, "Index",
  CellTags->"GenerateSG"],
Cell[45515, 2286, 144, 6, 16, "Index",
  CellTags->"GreenHQT"],
Cell[45662, 2294, 144, 6, 16, "Index",
  CellTags->"GreenJQT"],
Cell[45809, 2302, 144, 6, 16, "Index",
  CellTags->"GreenLQT"],
Cell[45956, 2310, 144, 6, 16, "Index",
  CellTags->"GreenRQT"],
Cell[46103, 2318, 150, 6, 16, "Index",
  CellTags->"HClassSize"],
Cell[46256, 2326, 141, 6, 16, "Index",
  CellTags->"HClassT"],
Cell[46400, 2334, 153, 6, 16, "Index",
  CellTags->"HTrivialQSG"],
Cell[46556, 2342, 138, 6, 16, "Index",
  CellTags->"IdealT"],
Cell[46697, 2350, 138, 6, 16, "Index",
  CellTags->"IdemSG"],
Cell[46838, 2358, 138, 6, 16, "Index",
  CellTags->"ImageT"],
Cell[46979, 2366, 147, 6, 16, "Index",
  CellTags->"InGroupSG"],
Cell[47129, 2374, 144, 6, 16, "Index",
  CellTags->"InverseT"],
Cell[47276, 2382, 153, 6, 16, "Index",
  CellTags->"JTrivialQSG"],
Cell[47432, 2390, 150, 6, 16, "Index",
  CellTags->"JTrivialSG"],
Cell[47585, 2398, 162, 6, 16, "Index",
  CellTags->"KernelImageToT"],
Cell[47750, 2406, 141, 6, 16, "Index",
  CellTags->"KernelT"],
Cell[47894, 2414, 150, 6, 16, "Index",
  CellTags->"LeftIdealT"],
Cell[48047, 2422, 150, 6, 16, "Index",
  CellTags->"LeftNullSG"],
Cell[48200, 2430, 147, 6, 16, "Index",
  CellTags->"LeftOneSG"],
Cell[48350, 2438, 183, 6, 16, "Index",
  CellTags->"LocallyCommutativeQSG"],
Cell[48536, 2446, 180, 6, 16, "Index",
  CellTags->"LocallyIdempotentQSG"],
Cell[48719, 2454, 144, 6, 16, "Index",
  CellTags->"Merge12T"],
Cell[48866, 2462, 156, 6, 16, "Index",
  CellTags->"MakeMonoidSG"],
Cell[49025, 2470, 147, 6, 16, "Index",
  CellTags->"MonoidQSG"],
Cell[49175, 2478, 156, 6, 16, "Index",
  CellTags->"NilpotentQSG"],
Cell[49334, 2486, 138, 6, 16, "Index",
  CellTags->"NullSG"],
Cell[49475, 2494, 135, 6, 16, "Index",
  CellTags->"OneSG"],
Cell[49613, 2502, 132, 6, 16, "Index",
  CellTags->"OneT"],
Cell[49748, 2510, 138, 6, 16, "Index",
  CellTags->"OrderT"],
Cell[49889, 2518, 153, 6, 16, "Index",
  CellTags->"PrintDClass"],
Cell[50045, 2526, 162, 6, 16, "Index",
  CellTags->"PrintEquations"],
Cell[50210, 2534, 162, 6, 16, "Index",
  CellTags->"PrintWitnesses"],
Cell[50375, 2542, 147, 6, 16, "Index",
  CellTags->"RegularSG"],
Cell[50525, 2550, 141, 6, 16, "Index",
  CellTags->"RandomT"],
Cell[50669, 2558, 135, 6, 16, "Index",
  CellTags->"RankT"],
Cell[50807, 2566, 153, 6, 16, "Index",
  CellTags->"RightIdealT"],
Cell[50963, 2574, 153, 6, 16, "Index",
  CellTags->"RightNullSG"],
Cell[51119, 2582, 150, 6, 16, "Index",
  CellTags->"RightOneSG"],
Cell[51272, 2590, 138, 6, 16, "Index",
  CellTags->"ShiftT"],
Cell[51413, 2598, 126, 6, 16, "Index",
  CellTags->"SG"],
Cell[51542, 2606, 141, 6, 16, "Index",
  CellTags->"SolveSG"],
Cell[51686, 2614, 168, 6, 16, "Index",
  CellTags->"SymmetricGroupSG"],
Cell[51857, 2622, 177, 6, 16, "Index",
  CellTags->"SyntacticCongruence"],
Cell[52037, 2630, 183, 6, 16, "Index",
  CellTags->"SyntacticHomomorphism"],
Cell[52223, 2638, 153, 6, 16, "Index",
  CellTags->"SyntacticSG"],
Cell[52379, 2646, 123, 6, 16, "Index",
  CellTags->"T"],
Cell[52505, 2654, 141, 6, 16, "Index",
  CellTags->"TableSG"],
Cell[52649, 2662, 168, 6, 16, "Index",
  CellTags->"ToIdentityString"],
Cell[52820, 2670, 168, 6, 16, "Index",
  CellTags->"TransformationSG"],
Cell[52991, 2678, 174, 6, 16, "Index",
  CellTags->"TransientPeriodicT"],
Cell[53168, 2686, 162, 6, 16, "Index",
  CellTags->"TranspositionT"],
Cell[53333, 2694, 153, 6, 16, "Index",
  CellTags->"UnitElement"],
Cell[53489, 2702, 180, 6, 16, "Index",
  CellTags->"EquationsToWitnesses"],
Cell[53672, 2710, 174, 6, 16, "Index",
  CellTags->"FromIdentityString"],
Cell[53849, 2718, 156, 6, 16, "Index",
  CellTags->"IrreducibleQ"],
Cell[54008, 2726, 156, 6, 16, "Index",
  CellTags->"PairsToRules"],
Cell[54167, 2734, 156, 6, 16, "Index",
  CellTags->"RulesToPairs"],
Cell[54326, 2742, 171, 6, 16, "Index",
  CellTags->"SimplifyEquations"],
Cell[54500, 2750, 183, 6, 16, "Index",
  CellTags->"SimplifyRewriteSystem"],
Cell[54686, 2758, 150, 6, 16, "Index",
  CellTags->"WordReduce"],
Cell[54839, 2766, 171, 6, 16, "Index",
  CellTags->"BooleanComplement"],
Cell[55013, 2774, 174, 6, 16, "Index",
  CellTags->"BooleanComposition"],
Cell[55190, 2782, 165, 6, 16, "Index",
  CellTags->"BooleanConverse"],
Cell[55358, 2790, 177, 6, 16, "Index",
  CellTags->"BooleanIntersection"],
Cell[55538, 2798, 156, 6, 16, "Index",
  CellTags->"BooleanPower"],
Cell[55697, 2806, 156, 6, 16, "Index",
  CellTags->"BooleanUnion"],
Cell[55856, 2814, 168, 6, 16, "Index",
  CellTags->"RelationToMatrix"],
Cell[56027, 2822, 147, 6, 16, "Index",
  CellTags->"ToClasses"],
Cell[56177, 2830, 171, 6, 16, "Index",
  CellTags->"TransitiveClosure"],
Cell[56351, 2838, 144, 6, 16, "Index",
  CellTags->"Warshall"],
Cell[56498, 2846, 156, 6, 16, "Index",
  CellTags->"AnalyzeOrbit"],
Cell[56657, 2854, 168, 6, 16, "Index",
  CellTags->"CartesianProduct"],
Cell[56828, 2862, 159, 6, 16, "Index",
  CellTags->"ClosureSearch"],
Cell[56990, 2870, 141, 6, 16, "Index",
  CellTags->"Closure"],
Cell[57134, 2878, 168, 6, 16, "Index",
  CellTags->"DeleteDuplicates"],
Cell[57305, 2886, 147, 6, 16, "Index",
  CellTags->"DisjointQ"],
Cell[57455, 2894, 144, 6, 16, "Index",
  CellTags->"EnumForm"],
Cell[57602, 2902, 156, 6, 16, "Index",
  CellTags->"FastPowerSet"],
Cell[57761, 2910, 153, 6, 16, "Index",
  CellTags->"Frequencies"],
Cell[57917, 2918, 159, 6, 16, "Index",
  CellTags->"FromBitVector"],
Cell[58079, 2926, 192, 6, 16, "Index",
  CellTags->"LongestCommonSubsequence"],
Cell[58274, 2934, 147, 6, 16, "Index",
  CellTags->"MakeIndex"],
Cell[58424, 2942, 186, 6, 16, "Index",
  CellTags->"NonDecreasingSequences"],
Cell[58613, 2950, 135, 6, 16, "Index",
  CellTags->"Pairs"],
Cell[58751, 2958, 150, 6, 16, "Index",
  CellTags->"Partitions"],
Cell[58904, 2966, 144, 6, 16, "Index",
  CellTags->"PowerSet"],
Cell[59051, 2974, 171, 6, 16, "Index",
  CellTags->"RandomPermutation"],
Cell[59225, 2982, 156, 6, 16, "Index",
  CellTags->"RankingRules"],
Cell[59384, 2990, 144, 6, 16, "Index",
  CellTags->"RootList"],
Cell[59531, 2998, 147, 6, 16, "Index",
  CellTags->"SelectorQ"],
Cell[59681, 3006, 141, 6, 16, "Index",
  CellTags->"Shuffle"],
Cell[59825, 3014, 141, 6, 16, "Index",
  CellTags->"SubsetQ"],
Cell[59969, 3022, 153, 6, 16, "Index",
  CellTags->"ToBitVector"],
Cell[60125, 3030, 138, 6, 16, "Index",
  CellTags->"ToList"],
Cell[60266, 3038, 141, 6, 16, "Index",
  CellTags->"ToPairs"],
Cell[60410, 3046, 138, 6, 16, "Index",
  CellTags->"Tuples"],
Cell[60551, 3054, 162, 6, 16, "Index",
  CellTags->"AssignFunction"],
Cell[60716, 3062, 135, 6, 16, "Index",
  CellTags->"Curry"],
Cell[60854, 3070, 150, 6, 16, "Index",
  CellTags->"Dependency"],
Cell[61007, 3078, 153, 6, 16, "Index",
  CellTags->"ExtAutomata"],
Cell[61163, 3086, 150, 6, 16, "Index",
  CellTags->"FlattenOne"],
Cell[61316, 3094, 162, 6, 16, "Index",
  CellTags->"FormatAutomata"],
Cell[61481, 3102, 156, 6, 16, "Index",
  CellTags->"PositionList"],
Cell[61640, 3110, 153, 6, 16, "Index",
  CellTags->"PositionOne"],
Cell[61796, 3118, 156, 6, 16, "Index",
  CellTags->"ReplaceParts"],
Cell[61955, 3126, 159, 6, 16, "Index",
  CellTags->"SelectOptions"],
Cell[62117, 3134, 138, 6, 16, "Index",
  CellTags->"Status"],
Cell[62258, 3142, 150, 6, 16, "Index",
  CellTags->"SymbolList"],
Cell[62411, 3150, 144, 6, 16, "Index",
  CellTags->"PostLoad"],
Cell[62558, 3158, 141, 6, 16, "Index",
  CellTags->"PreLoad"],
Cell[62702, 3166, 138, 6, 16, "Index",
  CellTags->"ColorQ"],
Cell[62843, 3174, 138, 6, 16, "Index",
  CellTags->"DoShow"],
Cell[62984, 3182, 144, 6, 16, "Index",
  CellTags->"GridLine"],
Cell[63131, 3190, 150, 6, 16, "Index",
  CellTags->"GridPoints"],
Cell[63284, 3198, 165, 6, 16, "Index",
  CellTags->"HueRasterColors"],
Cell[63452, 3206, 159, 6, 16, "Index",
  CellTags->"MakePlotRange"],
Cell[63614, 3214, 171, 6, 16, "Index",
  CellTags->"PlotComputationFA"],
Cell[63788, 3222, 156, 6, 16, "Index",
  CellTags->"PlotFunction"],
Cell[63947, 3230, 150, 6, 16, "Index",
  CellTags->"PlotMatrix"],
Cell[64100, 3238, 156, 6, 16, "Index",
  CellTags->"PlotRelation"],
Cell[64259, 3246, 153, 6, 16, "Index",
  CellTags->"PlotTDGraph"],
Cell[64415, 3254, 135, 6, 16, "Index",
  CellTags->"PlotT"],
Cell[64553, 3262, 147, 6, 16, "Index",
  CellTags->"ShowArray"],
Cell[64703, 3270, 159, 6, 16, "Index",
  CellTags->"StaircasePlot"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

